//Private
//var CadetTextRun = require("./CadetTextRunNode.js");
//var CadetStyle = require("./CadetStyleNode.js");
//var _intime=0;
//var _outtime=0;
//var _textRuns=[];


//Public
module.exports = CadetEvent;

function CadetEvent(i,o,a) {
	var CadetTextRun = require("./CadetTextRunNode.js");
	var CadetStyle = require("./CadetStyleNode.js");
    this.intime = i;
    this.outtime = o;
    this.align = 2;
    if( a ) this.align = a;
    this.textRuns = [];
    //console.log("CadetEvent: Module Contructed: with in=["+_intime+"] out=["+_outtime+"]");
}

CadetEvent.prototype.getIntime = function(){
	return(this.intime);
}
CadetEvent.prototype.getOuttime = function(){
	return(this.outtime);
}
CadetEvent.prototype.setIntime = function(n){
	this.intime = n;
}
CadetEvent.prototype.setOuttime = function(n){
	this.outtime = n;
}

CadetEvent.prototype.getText = function(){
	var sfoo="";
	for(var i=0; i<this.textRuns.length; i++){
		sfoo += this.textRuns[i].getText();
	}
	return sfoo;
}

CadetEvent.prototype.addRun = function(r, newline){
	if( newline ){ //first add a newline run, then the text run
		var newlineStyle = new CadetStyle(false, false, false, "white", "black", true);
		var newlineRun = new CadetTextRun(newlineStyle, "");
		this.textRuns.push(newlineRun);
		this.textRuns.push(r);
	} else {	//the first text run, just add it
		this.textRuns.push(r);
	}
    //console.log("CadetEvent:addRun: with r=["+r.toString()+"]");
}

CadetEvent.prototype.getRun = function(i){
    //console.log("CadetEvent:getRun("+i+"): =["+_textRuns[i].toString()+"]");
}

CadetEvent.prototype.toString = function() {
	//console.log("CadetEvent:toString hello world");
	//console.log("in=["+_intime+"] out=["+_outtime+"]");
	
	var sfoo="CadetEvent: ";
	//sfoo += " linebreak:"+_linebreak;
	sfoo += "intime:"+this.intime;
	sfoo += ", outtime:"+this.outtime;
	sfoo += ", align:"+this.align;
	sfoo += ", runsCount:"+this.textRuns.length;
	return(sfoo.trim());
};
CadetEvent.prototype.printTimes = function() {
	console.log("CadetEvent: in=["+this.intime+"] out=["+this.outtime+"]");
};

