//var cadet;
var VERSION = "1.0.001";
var DEBUG = false;
var DIRTY = false;
var LEAVE_CLEAN = false;
var SCREEN_REFRESH_ON = true;
var _inModal = false;	//keystroke trapping ok
var _inShortcutsModeless = false;
var ALIGN_LEFT = 1;
var ALIGN_CENTER = 2;
var ALIGN_RIGHT = 3;
var CADET_DEFAULT_STYLE;
var DLG_MODE_OPEN = 1;
var DLG_MODE_SAVE = 2;
var DLG_MODE_SAVE_TYPE = 3;
var _dlg_mode = DLG_MODE_OPEN;
var _webroot = "";
var _selPoint = null;
var bContentFocused = false;
var bMarking = false;
var markRow1 = -1, markRow2 = -1;
var blockData = [];

// ableplayer 
var ableplayer = null;

//var mypopup;
//Timecode types
var ZEROS = "00:00:00.00";
var INFINITY = "24:00:00.00";
var HIDDEN_TIME = ""; //"99:99:99.99";
var DEFAULT_CAPTION = " ";//" ";  "&nbsp;";  //"caption-here" "&nbsp;"
//Edit Modes
//var _bTranscriptionMode = false;
var EDITMODE_TRANSCRIBE = 1;
var EDITMODE_TIME = 2;
var EDITMODE_REVIEW = 3;
var _editMode = EDITMODE_TRANSCRIBE;
//Miscellaneous
var intervalRefresh = null;
var refreshing = false;
var refreshDelay = 100;// 0.1 second
var MIN_SCREEN_TIME = 2.99; //default display interval in seconds
var MIN_BLINK_TIME = 0.01; //default interval between outtime and next intime, in seconds
var QONCLICKINEDIT = false;
var QONCLICKINREVIEW = false;

var DEFAULT_WEBPROJECT_DIR = "";
var DEFAULT_WEBPROJECT_FILE = "Untitled.cadet";
var DEFAULT_CADET_EXTENTION = ".cadet";

//Export Types
var EXPORT_TYPE_INDEX_VTT=0;
var EXPORT_TYPE_INDEX_SRT=1;
var EXPORT_TYPE_INDEX_QTTEXT=2;
var EXPORT_TYPE_INDEX_TTML=3;
var EXPORT_TYPE_INDEX_SAMI=4;
var EXPORT_TYPE_INDEX_PLAIN=5;
var EXPORT_TYPE_VTT = "vtt";
var EXPORT_TYPE_SRT = "srt";
var EXPORT_TYPE_QTTEXT = "qttext";
var EXPORT_TYPE_TTML = "ttml";
var EXPORT_TYPE_SAMI = "sami";
var EXPORT_TYPE_PLAIN = "plain";
//Export Types HUMAN READABLE
var EXPORT_TYPE_HUMAN_VTT = "WebVTT";
var EXPORT_TYPE_HUMAN_SRT = "SRT";
var EXPORT_TYPE_HUMAN_QTTEXT = "QTtext";
var EXPORT_TYPE_HUMAN_TTML = "TTML";
var EXPORT_TYPE_HUMAN_SAMI = "SAMI";
var EXPORT_TYPE_HUMAN_PLAIN = "Plain";
var EXPORT_TYPE_MAP = [
						{internal:EXPORT_TYPE_VTT, external:EXPORT_TYPE_HUMAN_VTT},
						{internal:EXPORT_TYPE_SRT, external:EXPORT_TYPE_HUMAN_SRT},
						{internal:EXPORT_TYPE_QTTEXT, external:EXPORT_TYPE_HUMAN_QTTEXT},
						{internal:EXPORT_TYPE_TTML, external:EXPORT_TYPE_HUMAN_TTML},
						{internal:EXPORT_TYPE_SAMI, external:EXPORT_TYPE_HUMAN_SAMI},
						{internal:EXPORT_TYPE_PLAIN, external:EXPORT_TYPE_HUMAN_PLAIN}
						];
//var EXPORT_TYPE_TEXTONLY = "textonly";
//Import Types
var IMPORT_TYPE_VTT = "vtt";
var IMPORT_TYPE_SRT = "srt";
var IMPORT_TYPE_QTTEXT = "qttext";
var IMPORT_TYPE_TTML = "ttml";
var IMPORT_TYPE_SAMI = "sami";
var IMPORT_TYPE_PLAIN = "plain";
//var IMPORT_TYPE_TEXTONLY = "textonly";

//Jump Increments
var DEFAULT_JUMP_TINY = 0.1; //playhead jump tiny increment seconds
var DEFAULT_JUMP_SMALL = 0.5; //playhead jump small increment seconds
var DEFAULT_JUMP_LARGE = 5.0; //playhead jump large increment seconds
var JUMP_TINY = DEFAULT_JUMP_TINY; //playhead jump tiny increment seconds
var JUMP_SMALL = DEFAULT_JUMP_SMALL; //playhead jump small increment seconds
var JUMP_LARGE = DEFAULT_JUMP_LARGE; //playhead jump large increment seconds
var RETURNRETURNADJUST = 0.0; //seconds subtracted from media time when used for intime suck on double return
var PLAY_SPEED_MAP = [.5, .75, 1, 1.25, 1.5, 1.75, 2];
var PLAY_SPEED_NORMAL_INDEX = 2; //3rd element, 1x, (normal)
var PLAY_SPEED_INDEX = PLAY_SPEED_NORMAL_INDEX;
var FASTER = 1;
var SLOWER = 2;

//Default Colors
var DEFAULT_DEFAULT_FORECOLOR = "white";
var DEFAULT_DEFAULT_BACKCOLOR = "black";
var DEFAULT_FORECOLOR = DEFAULT_DEFAULT_FORECOLOR; //saved in cadet.config
var DEFAULT_BACKCOLOR = DEFAULT_DEFAULT_BACKCOLOR; //saved in cadet.config

//FILE EXTENSION maps
var INCLUDE_ALL_MAP = ["*"];
var INCLUDE_PROJECT_MAP = [".cadet"];
var INCLUDE_MEDIA_MAP = [".mp4",".mpg",".m4v",".mov",".ogg",".mp3"];
var INCLUDE_AUDIO_MAP = [".mp3",".wav"];
var INCLUDE_VTT_MAP = [".vtt",".webvtt"];
var INCLUDE_SRT_MAP = [".srt"];
var INCLUDE_TTML_MAP = [".ttml",".dfxp",".xml"];
var INCLUDE_SAMI_MAP = [".smi",".sami"];
var INCLUDE_QTTEXT_MAP = [".txt"];
var INCLUDE_PLAINTEXT_MAP = [".txt"];
var INCLUDE_EXPORT_ALL_MAP = [".vtt",".webvtt",".srt",".txt",".smi",".sami",".ttml",".dfxp",".xml"];
var INCLUDE_MAP_IN_USE = INCLUDE_ALL_MAP;

/*
BUGS
- video width shouldn't be hardwired, find it and delete italic
- cadet-server.js.... reload webroot after config save

TO-DO
- font face/size
- other export formats (WebVTT,SRT done already)
- other keyboard shortcuts added to key handler??
- allow URL for path to media (instead of just local file)
- alignment buttons (left center right)

DONE
- editable timecodes

*/


/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
//
//	C a d e t E d i t o r
//
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
(function  () {

//	$(document).ready (function () {


		var moduleName = "CadetEditor"; // constructor
		var instanceCount = 0;

		// here we assign the constructor to the global variable, but we could assign an instance if we wanted to provide a singleton
		var module = window[moduleName] = Module;

		/*
			function Module (userOptions) {
			var options = {
				_theTable: null,
			}; // defaults
			//options = _.extend (options, userOptions);
		*/	
		
	
		function Module (cfg, $p, $t, t) {
			/// PRIVATE INSTANCE VARIABLES	
			//var foo = "bar";	
			var _mediaFilename;
			var _mediaDir;
			var _ttFilename;
			var _trackFilename;
			var _workingDir;
			var _mediaUriDir;
			var _cfg = cfg;
			var $player = $p
			var $table = $t
			var _table = t; //internal CadetTable object
			var _tbodyElement = $table.children('tbody')[0]; //$($table, "tbody")[0];
			var _data = new CadetData(_cfg);
			var _currentRow = -1;
			var _defaultStyle = new CadetStyle();
			var _currentStyle = _defaultStyle;


			///PUBLIC METHODS
			this.showKeyboard = showKeyboard;
			//this.openProjectFile = openProjectFile;
			this.tryNewProject = tryNewProject;
			this.tryOpenProject = tryOpenProject;
			this.configCadet = configCadet;
			this.openMediaFile = openMediaFile;
			this.openMediaFromFile = openMediaFromFile;
			this.setMediaFromURL = setMediaFromURL;
			this.playPauseMedia = playPauseMedia;
			this.playerIsPaused = playerIsPaused;
			this.data = _data;
			this.table = _table;
			this.tryClear = tryClear;
			this.clear = clear;
			this.getCurrentRow = getCurrentRow;
			this.setCurrentRow = setCurrentRow;
			this.addRowBefore = addRowBefore;
			this.addRowAfter = addRowAfter;
			this.deleteEvent = deleteEvent;
			this.exportDataAs = exportDataAs;
			//this.exportAll = exportAll;
			this.importDataFrom = importDataFrom;
			this.doSaveProject = doSaveProject;
			//this.saveData = saveData;
			//this.exportVTT = exportVTT;
			//this.exportQTtext = exportQTtext;
			this.doExportWhere = doExportWhere;
			this.setTextAlign = setTextAlign;
			this.makeBold = makeBold;
			this.makeItalic = makeItalic;
			this.makeUnderline = makeUnderline;
			this.makeColor = makeColor;
			this.makeBGColor = makeBGColor;
			this.setIntime = setIntime;
			this.setOuttime = setOuttime;
			this.checkTimecodes = checkTimecodes;
			this.tryCheckTimecodes = tryCheckTimecodes;
			this.cueIntime = cueIntime;
			this.cueOuttime = cueOuttime;
			this.syncToPlayhead = syncToPlayhead;
			this.cueMedia = cueMedia;
			this.mediaJump = mediaJump;
			this.toggleMode = toggleMode;
			this.getSelection = getSelection;
			this.getMediaFilename = getMediaFilename;
			this.fooTest = fooTest;
			this.doLogin = doLogin;
			this.refreshCaptions = refreshCaptions;
			this.toggleAutoRefreshCaptions = toggleAutoRefreshCaptions;
			this.getMediaTime = getMediaTime;
			this.insertMusicalNote = insertMusicalNote;
			this.quitCadet = quitCadet;
			this.clearCurrentTimes = clearCurrentTimes;
			this.tryClearAllTimes = tryClearAllTimes;
			this.tryClearOutTimes = tryClearOutTimes;
			this.gotoCurrent = gotoCurrent;
			this.editFind = editFind;
			this.editReplace = editReplace;
			this.findText = findText;
			this.offsetTimecodes = offsetTimecodes;
			this.tryOffsetTimecodes = tryOffsetTimecodes;
			this.setMark = setMark;
			this.editMark = editMark;
			this.blockCut = blockCut;
			this.blockCopy = blockCopy;
			this.blockPaste = blockPaste;
			this.makeDirty = makeDirty;
			this.setPlayerSpeed = setPlayerSpeed;
			this.setPlayerSpeedNormal = setPlayerSpeedNormal;
			this.bumpPlayerSpeed = bumpPlayerSpeed;
			this.doPlayerStop = doPlayerStop;
			
			init();
			
			//attach this editor to the table
			_table.setEditor(this);//this doesn't work, why not!!!!!!    
			
			rebuildTable();
			
			makeColor(DEFAULT_FORECOLOR);//"white");
			makeBGColor(DEFAULT_BACKCOLOR);//"black");

			function fooTest(){
				debug("CADET:fooTest");
				debug("*****************");
				debug("*****************");
				//var cs = new CadetStyle();
				//crawlCaptionNodes(_tbodyElement.rows[0].cells[3].firstChild, cs);
				//debug("CADET:fooTest table.getTextAlign=["+_table.getTextAlign()+"]");
				
				//buildStyleRun(_currentRow);
				//debug("row=["+_currentRow+"] html=["+_table.getHtmlText(_currentRow)+"]");
				
				
				//debug("CADET:fooTest  innerHTML=["+_table.getHtmlText(_table.getCurrentRow())+"]");
				//_table.getHtmlText(_table.getCurrentRow());
				
				//importtest();
				//debug("table currentRow()=["+_table.getCurrentRow()+"]");
				$.post("/quit/", { thedata: {} }, function(temp) {
					debug("EDITOR: fooTest:post(/quit/): succeeded");
					
				})
				.fail( function(xhr, textStatus, error) {
					debug("EDITOR: fooTest:post(/quit/): failure xhr status=["+xhr.status+"]  responseText=["+xhr.responseText+"]");
				});
							
				
			}//fooTest
			
			function setPlayerSpeed( n ){
				$("video")[0].playbackRate = n;
				$("#playSpeed").text(n.toString());
			}//setPlayerSpeed
			function setPlayerSpeedNormal(){
				var speed = PLAY_SPEED_MAP[PLAY_SPEED_NORMAL_INDEX];
				$("video")[0].playbackRate = speed;
				$("#playSpeed").text(speed.toString());
				PLAY_SPEED_INDEX = PLAY_SPEED_NORMAL_INDEX;
			}//setPlayerSpeedNormal
			function bumpPlayerSpeed(which){
				//faster or slower
				if( which == FASTER ){
					if( (PLAY_SPEED_INDEX + 1) < PLAY_SPEED_MAP.length ) {
						PLAY_SPEED_INDEX += 1;
					}
				} else { //slower
					if( (PLAY_SPEED_INDEX - 1) >= 0 ) {
						PLAY_SPEED_INDEX -= 1;
					}
				}
				setPlayerSpeed(PLAY_SPEED_MAP[PLAY_SPEED_INDEX]);
			}//playerSpeedBump
			function doPlayerStop(){
				//stop the player, and cue to zero
				stopMedia();
				cueMedia(0.0);
			}//doPlayerStop
			
			function makeDirty(b){
				DIRTY = b;
				if( DIRTY ){
					$("#dirty").addClass("dirty");
					$("#dirty").css("display","block");
				} else {
					$("#dirty").removeClass("dirty");
					$("#dirty").css("display","none");
				}
			}
			
			/////////////////////////////////
			// QUIT sequence....
			function quitCadet(){
				debug("EDITOR: quitCadet enter");
				if( DIRTY ){
					confirm("Your project has unsaved changes. Quit anyway?", quitServer)
				} else {
					quitServer();
				}
			}//quitCadet
			function quitServer(){
				//debug("EDITOR: quitServer enter");
				
				/**/
				//load the quitpage so cadet UI doesn't remain visible
				$("body").load("/-cad3t-/quitpage.html", function(){
				
					/*
					//this causes the node app to terminate
					$.post("/quit/", { thedata: {} }, function(temp) {
						//debug("EDITOR: fooTest:post(/quit/): succeeded");
					})
					.fail( function(xhr, textStatus, error) {
						//debug("EDITOR: fooTest:post(/quit/): failure xhr status=["+xhr.status+"]  responseText=["+xhr.responseText+"]");
					});
					*/
					$.post("/quit/", { thedata: {} }, null );
					
					//remove the window catch
					window.onbeforeunload = null;

					
				});
				
				//load the quitpage so cadet UI doesn't remain visible
				//$("body").load("/-cad3t-/quitpage.html", null);
									
				//close the window
				//window.open('','_self').close();
		}//quitServer
			/////////////////////////////////
			
			function doLogin(){
				debug("CADET-DATA: doLogin");
			}//doLogin

			function showKeyboard(){
				showHelpShortcuts();  
			}//openMediaFile
			
			function insertMusicalNote(){
				_table.insertMusicalNote();
				DIRTY = true;
				makeDirty(true);
			}//insertMusicalNote
		
			function tryNewProject(){
				//confirm("Discard current project? Make sure it's saved!!!", newProject);
				//return;
			
				//not sure yet how to efficiently catch DIRTY'ing the file
				if( DIRTY )
					confirm("Your project has unsaved changes.<br>Start a new project anyway?", newProject, 400, 400);
				else
					newProject();
			}//tryNewProject
			function newProject(){
				_cfg.setMediaInfo("", "");
				_cfg.setWebProject("", "");
				_table.newProject();
				_table.setupMediaPlayer(null, "", "");
				_table.UIsetProjectFile("/Untitled.cadet");
				_table.UIsetMedia("No Media File");
				DIRTY = false;
				makeDirty(false);
			}//newProject
			
			function getReadyForExport(){
				_cfg.getReadyForExport();
				this.config = _cfg;
				_data.getReadyForExport();
				
				//clean up trailing blank lines
				cleanupBlankLines();
				
				this.data = _data;
			}//getReadyForExport
			
			function init(){
				CADET_DEFAULT_STYLE = new CadetStyle();
				
				/*
				//retrieve webroot from server
				$.get("/getwebroot/", {  }, function(temp) {
					_webroot = JSON.parse(temp).webroot;
					
					//update the UI for project file
					_table.UIsetProjectFile(_webroot.replace(/\/+$/, "") + _cfg.webProjectDir + "/" + _cfg.webProjectFile);
				})
				.fail( function(xhr, textStatus, error) {
					debug("CADET:init:post(/getwebroot/: failure xhr.status=["+xhr.status+"]");
					debug("CADET:init:post(/getwebroot/: failure xhr.responseText=["+xhr.responseText+"]");
				});
				*/
				
				makeDebugVisible(DEBUG);
				
				////////////////////////////////
				//  Retrieve CONFIG values
				$.post("/configread?rand="+Math.random(), { thedata: {} }, function(temp) {
					var o;
					if( temp.length > 0 ){
						o = JSON.parse(temp);
						//debug("EDITOR:init:post(/configread/ success response=["+JSON.stringify(o,null,2)+"]");
						
						//webroot
						if( o.defaults.webroot ) _webroot = o.defaults.webroot;

						// scrubbing increments
						if( o.defaults.jumpTiny ) JUMP_TINY = o.defaults.jumpTiny;
						if( o.defaults.jumpSmall ) JUMP_SMALL = o.defaults.jumpSmall;
						if( o.defaults.jumpLarge ) JUMP_LARGE = o.defaults.jumpLarge;
						//return-return time adjust
						if( o.defaults.returnreturnadjust ) RETURNRETURNADJUST = o.defaults.returnreturnadjust;
						
						//includeMediaMap
						if( o.defaults.includeMediaMap ) INCLUDE_MEDIA_MAP = o.defaults.includeMediaMap;
						
						// debug visibility
						if( o.defaults.debugVisible ) DEBUG = o.defaults.debugVisible;
						makeDebugVisible( DEBUG );
						
						//default colors
						if( o.defaults.foreColor ) DEFAULT_FORECOLOR = o.defaults.foreColor;
						if( o.defaults.backColor ) DEFAULT_BACKCOLOR = o.defaults.backColor;
						
						//QONCLICK
						if( o.defaults.qOnClickInEdit ) QONCLICKINEDIT = o.defaults.qOnClickInEdit;
						if( o.defaults.qOnClickInReview ) QONCLICKINREVIEW = o.defaults.qOnClickInReview;
						var foo=true;
						
						//debug("EDITOR:init:post(/configread/ calling clearAndLeaveSingle with foreColor=["+DEFAULT_FORECOLOR+"]");
						//this updates the bare table with the correct default colors
						_table.clearAndLeaveSingle();
				
					}
			
				})
				.fail( function(xhr, textStatus, error) {
					debug("EDITOR:init:post(/configread/: failure xhr.status=["+xhr.status+"] xhr.responseText=["+xhr.responseText+"]");
				});
				
				//update version
				$("#version").text("Version: "+VERSION);
				
				

				//update the UI for project file
				_table.UIsetProjectFile(_webroot.replace(/\/+$/, "") + _cfg.webProjectDir + "/" + _cfg.webProjectFile );
				
				setCurrentRow(0);
				
			}//init
			
			function editMark(){
				debug("EDITOR: editMark: enter");
				setMark();
				debug("EDITOR: editMark: exit");
			}//editMark
			function setMark(){
				debug("EDITOR: setMark: enter");
				if( bMarking ){
					if( markRow1 >=0 && markRow2 >=0 ){  //just unset
						bMarking = false;
						markRow1 = -1;
						markRow2 = -1;
						markRows(false);
					} else if( getCurrentRow() == markRow1 ){  //if trying to mark same row, just unset
						bMarking = false;
						markRow1 = -1;
						markRow2 = -1;
						markRows(false);
						//return;
					} else {
						markRow2 = getCurrentRow();
						if( markRow2 < markRow1 ){	//swap endpoints
							var temp = markRow1;
							markRow1 = markRow2;
							markRow2 = temp;
						}
						markRows(true);
					}
					
				} else {
					bMarking = true;
					markRow1 = getCurrentRow();
					markRows(true);
				}
				debug("EDITOR: setMark: exit; bMarking=["+bMarking+"] markRow1=["+markRow1+"] markRow2=["+markRow2+"]");
			}//setMark
			function markRows(b){
				if( b ){	//MARK
					
					if( (markRow1 >= 0) && (markRow2 >= 0) ){ // both endpoints defined, highlight from mark1 to mark2
						for( var i=markRow1; i<=markRow2; i++ )
							_table.markRow(i);
	
					} else if( (markRow1 >= 0) ){ //just first endpoint, so highlight mark1
							_table.markRow(markRow1);
					
					} 					
				} else {	//UNMARK
					_table.unmarkAll()
				}
				
			}//markRows
			
			function blockCut(){
				blockData.length = 0;
				if( bMarking && (markRow1>=0) && (markRow2>=0) ){
					//sort
					if( markRow2 < markRow1 ){
						var temp = markRow1;
						markRow1 = markRow2;
						markRow2 = temp;
					}
					var oldcurrow = markRow1;

					blockCopy();
					
					//delete the block of events
					for( var i=markRow1; i<=markRow2; i++ ){
						_table.deleteSomeEvent(markRow1);
					}
						
					//don't leave no rows
					if( _table.getRowCount() == 0 ){
						_table.clearAndLeaveSingle();
					}

					//unset marking
					bMarking = false;
					markRow1=-1;
					markRow2=-1;
					
					//select old index for currentRow
					_table.setCurrentRow(oldcurrow)
				
				} else {
					var oldcurrow = _table.getCurrentRow();
					//copy the current event
					blockCopy();
					
					//delete the current event
					_table.deleteEvent();
					
					//don't leave no rows
					if( _table.getRowCount() == 0 ){
						_table.clearAndLeaveSingle();
					}
					_table.setCurrentRow(oldcurrow)
				}
				DIRTY = true;
				makeDirty(true);
			}//blockCut
			
			function blockCopy(){
				blockData.length = 0;
				if( bMarking && (markRow1>=0) && (markRow2>=0) ){
					//sort
					if( markRow2 < markRow1 ){
						var temp = markRow1;
						markRow1 = markRow2;
						markRow2 = temp;
					}
					//debug("blockCopy: mark1=["+markRow1+"] mark2=["+markRow2+"]");
					for( var i=markRow1; i<=markRow2; i++ ){
						var o = {};
						o.intime = _table.getIntime(i);
						o.outtime = _table.getOuttime(i);
						o.text = _table.getHtmlText(i);
						blockData.push(o);
					}
				
				} else {
					var o = {};
					o.intime = _table.getIntime(_table.getCurrentRow());
					o.outtime = _table.getOuttime(_table.getCurrentRow());
					o.text = _table.getHtmlText(_table.getCurrentRow());
					blockData.push(o);
				}
				//debug("EDITOR:blockCopy: blockData = ["+JSON.stringify(blockData)+"]");
			}//blockCopy
			
			function blockPaste(){
				/*
				for( var i=0; i<blockData.length; i++ ){
					//debug("EDITOR:blockPaste: blockData["+i+"] = ["+JSON.stringify(blockData[i])+"]");
				}
				*/
				
				//if block is selected, then cut it, otherwise just insert above the current row
				if( bMarking && (markRow1>=0) && (markRow2>=0) ){
					blockCut();				
				}
				
				//modeled on dataToTable
				var oldcurrow = _table.getCurrentRow();//markRow1??
				var newcurrow = oldcurrow;
				var shtml = "";
				var o={};
				for(var i=0; i<blockData.length; i++){
					doStatus("Processing event #"+i);
					o = blockData[i];
					
					//inserts file ABOVE current row
					addRowAt(newcurrow, o.intime.timecodeToNumber(), o.outtime.timecodeToNumber(), " ");
					setCurrentRow(newcurrow);
															
					shtml = o.text;
					
					//set total text html;
					//_table.setSectionHtml(newcurrow,shtml);
					_table.setCellHtml(newcurrow,shtml);
					
					//setCurrentRow(newcurrow+1);
					setCurrentRow(newcurrow+1);
					newcurrow = _table.getCurrentRow();
					
				}
				_table.setCurrentRow(oldcurrow);
				_table.setSelectionCurrentRowToBeginning()

				//unset marking
				bMarking = false;
				markRow1=-1;
				markRow2=-1;
				DIRTY = true;
				makeDirty(true);
			}//blockPaste
			
			function getMediaFilename(){
				return _cfg.getMediaFilename();
			}
			
			function getMediaTime(){
				var ntime;
				ntime = $("#cadetvideo")[0].currentTime;
				return( ntime );
			}//getMediaTime
			function setIntime(){
				var ntime = getMediaTime();
				//debug("EDITOR: setIntime which=["+_table.getCurrentRow()+"] time=["+ntime.toTimecode()+"]");
				//update model
				/////////_data.setIntime(_currentRow, ntime);
				//update visuals
				_table.setIntime(_table.getCurrentRow(), ntime);
								
				refreshCaptions();
			}//setIntime
			function setOuttime(){
				var ntime = getMediaTime();
				//debug("EDITOR: setOuttime which=["+_currentRow+"] time=["+ntime.toTimecode()+"]");
				//update model
				////////_data.setOuttime(_currentRow, ntime);
				//update visuals
				_table.setOuttime(_table.getCurrentRow(), ntime);
				refreshCaptions();
			}//setOuttime
			
			function tryCheckTimecodes(){
				doStatus("Checking timecodes...", true);
				if( checkTimecodes() ){
					doStatus("Timecodes OK.");
					showAlert("Timecodes OK.", 600, 600);
				} else {
					doStatus("Timecode errors found.");
					showAlert("Timecode errors found.", 600, 600);
				}
				
			}//tryCheckTimecodes
			function checkTimecodes(){
				//debug("EDITOR: checkTimecodes");
				var retval = true;
				var len = _table.getRowCount();
				var lasttime = -2;
				var thistime = -1;
				for( var i=0; i<len; i++ ){
					//check intime
					thistime = _table.getIntime(i).timecodeToNumber();
					if( thistime >= 0 ){
							
						if( thistime <= lasttime ){
							doStatus("<a href='#' onclick='focusCaptionCell("+i+");'>&nbsp;&nbsp;Caption #"+(i+1)+": START time out of sequence</a>");
							//setCurrentRow(i);
							//_table.focusCaptionCell(i);
							retval = false;
						} else {
							lasttime = thistime;
							//now check outtime
							thistime = _table.getOuttime(i).timecodeToNumber();
							if( thistime >= 0 ){
								if( thistime <= lasttime ){
									doStatus("<a href='#' onclick='focusCaptionCell("+i+");'>&nbsp;&nbsp;Caption #"+(i+1)+": END time out of sequence</a>");
									//setCurrentRow(i);
									//_table.focusCaptionCell(i);
									retval = false;
								} else {
									lasttime = thistime;
								}
								
							}//an actual outtime
							
						}

					}//an actual intime
				}//
				
				return retval;
			}//checkTimecodes
			
			function checkForText(){
				//debug("EDITOR: checkForText");
				var bfoundtext=false, thetext="";
				var len = _table.getRowCount();
				
				for( var i=0; i<len; i++ ){
					thetext = _table.getText(i);
					if( thetext.trim().length > 0 )
						bfoundtext = true;
				}
				
				return bfoundtext;
			}//checkForText
			
			function checkOffsetTimecodes(ifirst, ilast, nOldTime, nNewTime){
				var bret = true, bfoundatime = false;
				var len = _table.getRowCount();
				var thistime = -1;
				var dif = nNewTime - nOldTime;//add this dif to each non-blank timecodeToNumber
				var thistimenew;
				for( var i=ifirst; i<=ilast; i++ ){
					//check intime
					thistime = _table.getIntime(i).timecodeToNumber();
					if( thistime >= 0 ){
						bfoundatime = true;
						thistimenew = thistime + dif;
						if( thistimenew < 0 ){
							doStatus("<a href='#' onclick='focusCaptionCell("+i+");'>&nbsp;&nbsp;Caption #"+(i+1)+": START offset by "+dif+"s would be &lt; 0</a>");
							bret = false;
						}
					}
					//check outtime
					thistime = _table.getOuttime(i).timecodeToNumber();
					if( thistime >= 0 ){
						bfoundatime = true;
						thistimenew = thistime + dif;
						if( thistimenew < 0 ){
							doStatus("<a href='#' onclick='focusCaptionCell("+i+");'>&nbsp;&nbsp;Caption #"+(i+1)+": END offset by "+dif+"s would be &lt; 0</a>");
							bret = false;
						}
					}
				}
				if( !bfoundatime ){
					doStatus("No timecodes found to offset.");
					bret = false;
				}
				return bret;
			}//checkOffsetTimecodes
			function offsetTimecodes(ifirst, ilast, nOldTime, nNewTime){
				var len = _table.getRowCount();
				var thistime = -1;
				var thistimenew;
				var dif = nNewTime - nOldTime;//add this dif to each non-blank timecodeToNumber
				
				//correct for 
				if( ilast < ifirst ){
					temp = ifirst;
					ifirst = ilast;
					ilast = temp;
				}
				
				if( dif < 0 ) 
				
				//check potential offsetting
				doStatus("Checking potential offsets", true);
				if(checkOffsetTimecodes(ifirst, ilast, nOldTime, nNewTime)){
					doStatus("Potential offsets  OK");
				} else {
					showAlert("Potential offset problems, see error links in status box", 600, 600);
					return;
				}
				
				
				for( var i=ifirst; i<=ilast; i++ ){
					//check intime
					thistime = _table.getIntime(i).timecodeToNumber();
					if( thistime >= 0 ){
						thistimenew = thistime + dif;
						_table.setIntime(i, thistimenew);
					}
					//check outtime
					thistime = _table.getOuttime(i).timecodeToNumber();
					if( thistime >= 0 ){
						thistimenew = thistime + dif;
						_table.setOuttime(i, thistimenew);
					}
				}
			}//offsetTimecodes
			function tryOffsetTimecodes(){
				//showOffset("" ,300,300, _table.getCurrentRow(), this, _table);
			}//tryOffsetTimecodes
			
			
			
			function cueIntime(){
				//_table.cueIntime(_table.getCurrentRow());
				cueMedia(_table.getIntime(_table.getCurrentRow()).timecodeToNumber());
			}//cueIntime
			function cueOuttime(){
				//_table.cueIntime(_table.getCurrentRow());
				cueMedia(_table.getOuttime(_table.getCurrentRow()).timecodeToNumber());
			}//cueOuttime
			
			function syncToPlayhead(){
				//get playhead time
				//var myVideo = $("#cadetvideo")[0];
				//if( myVideo ){
					var sometime = getMediaTime();
					var somerow=-1;
					//debug("EDITOR:syncToPlayhead: looking for time=["+sometime+"] ["+sometime.toTimecode()+"]");
					somerow = _table.syncToTime(sometime);
					if( somerow >= 0 )
						_table.setCurrentRow(somerow);
						_table.setSelectionCurrentRowToBeginning()
				//} else {
				//	//do nothing
				//}
				return;
			}//syncToPlayhead

			function setTextAlign(ialign){
				//if( _table.inContentColumn() ){
					_table.setTextAlign(ialign);
					toggleAutoRefreshCaptions(true);
					DIRTY = true;
					makeDirty(true);
				//}
			}//setTextAlign
			function insertMusicNote(){
				_table.insertMusicalNote();
			}//insertMusicNote
			function makeBold( b ){
				if( _table.inContentColumn() ){
					//debug("data:makeBold");
					_table.makeBold(b);
					toggleAutoRefreshCaptions(true);
					DIRTY = true;
					makeDirty(true);
				}
			}//makeBold
			function makeItalic( b ){
				//debug("EDITOR: makeBold");
				if( _table.inContentColumn() ){
					_table.makeItalic(b);
					toggleAutoRefreshCaptions(true);
					DIRTY = true;
					makeDirty(true);
				}
			}//makeItalic
			function makeUnderline( b ){
				//debug("EDITOR: makeBold");
				if( _table.inContentColumn() ){
					_table.makeUnderline(b);
					toggleAutoRefreshCaptions(true);
					DIRTY = true;
					makeDirty(true);
				}
			}//makeUnderline
			function makeColor( c ){
				//debug("EDITOR: makeBold");
				if( _table.inContentColumn() ){
					_table.makeColor(c);
					toggleAutoRefreshCaptions(true);
					DIRTY = true;
					makeDirty(true);
				}
			}//makeColor
			function makeBGColor( c ){
				//debug("EDITOR: makeBold");
				if( _table.inContentColumn() ){
					_table.makeBGColor(c);
					toggleAutoRefreshCaptions(true);
					DIRTY = true;
					makeDirty(true);
				}
			}//makeColor
			
			function getCurrentRow(){
				//return( _currentRow );
				return( _table.getCurrentRow() );
			}//getCurrentRow
			function setCurrentRow( r ){
				_table.setCurrentRow( r );
			}//setCurrentRow
			function setCurrentRowOld( r ){
				if( r>=0 && r<=_data.count() ){
					_currentRow = r ;
					_table.setCurrentRow( r );
				}
			}//setCurrentRowOld
			function getSelection(){
				var userSelection;// = window.getSelection();
				if (window.getSelection) {
					userSelection = window.getSelection();
				}
				else if (document.selection) { // should come last; Opera!
					userSelection = document.selection.createRange();
				}
				var startID, startOffset, endID, endOffset;
				if( userSelection.baseNode ){
					startID = userSelection.baseNode.parentElement.id;
					startOffset = userSelection.baseOffset;
					endID = userSelection.extentNode.parentElement.id;
					endOffset = userSelection.extentOffset;
				} else {
					startID = userSelection.anchorNode.parentElement.id;
					startOffset = userSelection.anchorOffset;
					endID = userSelection.focusNode.parentElement.id;
					endOffset = userSelection.focusOffset;
				}
				debug("EDITOR: getSelection: startID=["+startID+"] startOffset=["+startOffset+"]");
				debug("EDITOR: getSelection: endID=["+endID+"] endOffset=["+endOffset+"]");
				
				//now make a range out of it
				var rang;
				if (userSelection.getRangeAt)
					rang = userSelection.getRangeAt(0);
				else { // Safari!
					rang = document.createRange();
					rang.setStart(selectionObject.anchorNode,selectionObject.anchorOffset);
					rang.setEnd(selectionObject.focusNode,selectionObject.focusOffset);
				}
				debug("EDITOR: getSelection: sel text=["+rang.toString()+"]");
				
				//debug("EDITOR: getSelection: now collapse the run");
				
			}//getSelection
			
			function gotoCurrent(){
				_table.gotoCurrent();
			}//gotoCurrent
			
			function addRowAt(iwhere, nin, nout, stext){
				//debug("EDITOR: addRowAt");
				if( iwhere < 0 ) iwhere = 0;
				//if( iwhere > _data.count-1 ) iwhere = _data.count;
				//_data.addEvent(iwhere, nin, nout, stext);
				_table.addRowAt(iwhere, nin.toTimecode(), nout.toTimecode(), stext);
				DIRTY = true;
				makeDirty(true);
			}//addRowAt
			
			function addRowBefore(nin, nout, stext){
				//debug("EDITOR:addRowBefore enter _currentRow=["+_currentRow+"]");
				//_table.addRowAt(_table.getCurrentRow(), nin.toTimecode(), nout.toTimecode(), stext);
				var foo = -1;//set to blank timecode
				_table.addRowAt(_table.getCurrentRow(), foo.toTimecode(), foo.toTimecode(), stext);
				//setCurrentRow(_currentRow);
				//debug("EDITOR:addRowBefore exit _currentRow=["+_currentRow+"]");
				DIRTY = true;
				makeDirty(true);
			}//addRowBefore
			
			function addRowAfter(nin, nout, stext){
				//debug("EDITOR:addRowAfter enter _currentRow=["+_currentRow+"] nin=["+nin+"] sin=["+nin.toTimecode()+"]");
				//_table.addRowAt(_table.getCurrentRow()+1, nin.toTimecode(), nout.toTimecode(), stext);
				var foo = -1;
				_table.addRowAt(_table.getCurrentRow()+1, foo.toTimecode(), foo.toTimecode(), stext);
				//debug("EDITOR:addRowAfter exit _currentRow=["+_currentRow+"]");
				DIRTY = true;
				makeDirty(true);
			}//addRowAfter
			
					
			function tryOpenProject(){
				//confirm("Discard current project? Make sure it's saved!!!", newProject);
				//return;
			
				//not sure yet how to efficiently catch DIRTY'ing the file
				if( DIRTY )
					confirm("Your project has unsaved changes.<br>Open a different project anyway?", openProjectFile, 400, 400);
				else
					openProjectFile();
			}//tryOpenProject
			function openProjectFile(){
				showFileBrowserModal(DLG_MODE_OPEN, DISPATCH_OPEN_PROJECT, openProjectFromFile, null, "Open Project", INCLUDE_PROJECT_MAP);  
			}//openProjectFile
			function openProjectFromFile() {
				//debug("EDITOR: openProjectFromFile: calling _fileBrowser.dumpPaths()");
				//_fileBrowser.dumpPaths();
				var thefile = _fileBrowser.getWebDir() + "/" + _fileBrowser.getWebFile();
				
				/*
				var myObject = JSON.parse(reader.result);
				debug("EDITOR: loadDataFromProjectFile: Stringfy=["+JSON.stringify(myObject)+"]");
				_data.events = myObject.events;
				//updateTable();
				projectToTable(myObject.events);
				*/
						
				var obj={};
				obj.projPath = thefile;	
				//$.post("/openProject/", JSON.stringify({ projPath: thisfile }), function(temp) {
				$.post("/openProject/", { thedata: JSON.stringify(obj) }, function(temp) {
					
					var oproj = JSON.parse(temp);
					//debug("EDITOR: openProjectFromFile:post(/openProject/): success response=["+JSON.stringify(oproj,null,2)+"]");
					
					
					perfStartTime = new Date();
					projectToTable(oproj.events);
					perfEndTime = new Date();
					doStatus("Elapsed time=["+itoeTimeDiff(perfStartTime, perfEndTime)+"]");

					setCurrentRow(0);
					//update UI
					_table.UIsetProjectFile(_webroot.replace(/\/+$/, "") + thefile);
					
					//open media clip from project
						//openMediaFromFile(true, oproj.config.mediaDir, oproj.config.mediaFilename);
					//update UI
						//_table.UIsetMedia(_webroot.replace(/\/+$/, "") + _mediaDir+"/"+_mediaFilename);
					
					deferredMediaDir = oproj.config.mediaDir;
					deferredMediaFilename = oproj.config.mediaFilename ? oproj.config.mediaFilename : "";
					//deferredErrorMsg = "Can't find media file [<span style='color:red;'>"+_webroot.replace(/\/+$/, "") + deferredMediaDir+"/"+deferredMediaFilename+"</span>]. Please open the media file.";
					//checkExists(_webroot.replace(/\/+$/, "") + deferredMediaDir+"/"+deferredMediaFilename, okToOpenMedia);
					deferredErrorMsg = "Can't find media file [<span style='color:red;'>"+ deferredMediaDir+"/"+deferredMediaFilename+"</span>]. Please open the media file.";

					DIRTY = false;
					makeDirty(false);
					LEAVE_CLEAN = true;//signal to openMediaFile() not to set the dirty bits

					checkExists(deferredMediaDir+"/"+deferredMediaFilename, okToOpenMedia);
					
					//save the file/path names to config
					_cfg.setWebProject(_fileBrowser.getWebDir(), _fileBrowser.getWebFile());
					
				})
				.fail( function(xhr, textStatus, error) {
					debug("EDITOR: openProjectFromFile:post(/openProject/): failure xhr status=["+xhr.status+"]  responseText=["+xhr.responseText+"]");
				});
														
			}//loadDataFromProjectFile
			var deferredMediaDir, deferredMediaFilename;
			function okToOpenMedia(){
					//open media clip from project
					openMediaFromFile(true, deferredMediaDir, deferredMediaFilename);
					//update UI
					_table.UIsetMedia(_webroot.replace(/\/+$/, "") + _mediaDir+"/"+_mediaFilename);
			}//okToOpenMedia
			function projectToTable(eventsJson){
				//remove table rows and re-create from project JSON
				//debug("EDITOR:projectToTable: ENTER");
								
				//debug("EDITOR:projectToTable: set up table events");
				_table.clearAndLeaveSingle();
				
				//update first (blank) rows
				_table.setIntime(0,eventsJson[0].intime);
				_table.setOuttime(0,eventsJson[0].outtime);
				_table.setHtmlText(0,eventsJson[0].htmlText);
				
				doStatus("Importing Project...")
				SCREEN_REFRESH_ON = false;
				for(var i=1; i<eventsJson.length; i++){
					doStatus("Event #"+i)
					//_table.addRowAfter(eventsJson[i].intime.toTimecode(), eventsJson[i].outtime.toTimecode(), "");
					//_table.setIntime(i,eventsJson[i].intime);
					//_table.setOuttime(i,eventsJson[i].outtime);
					//_table.setHtmlText(i,eventsJson[i].htmlText);
					_table.addRowAt(i, eventsJson[i].intime.toTimecode(), eventsJson[i].outtime.toTimecode(), eventsJson[i].htmlText, true);
				}
				doStatus("Project import complete.")
				SCREEN_REFRESH_ON = true;
				_table.updateRowNumbers();
				_table.setCurrentRow(0);
				
			}//projectToTable	
			
			function checkExists(s, funcToCall){
				//check if s exists on filesystem
				//debug("EDITOR:checkExist: enter to check=["+s+"]");
				var obj={};
				obj.src = s;
				$.post("/checkExists/", { thedata: JSON.stringify(obj) }, function(temp) {
					
					//debug("EDITOR:checkExist:post(/checkExist/): server returned=["+temp+"]");
					//debug("EDITOR:checkExist:post(/checkExist/): EXISTS!! ["+s+"]");
					if( funcToCall ){
						//debug("EDITOR:checkExist:post(/checkExist/): and calling funcToCall...");
						funcToCall();
					} else {
						//debug("EDITOR:checkExist:post(/checkExist/): but nothing to do...");
					}
					
				})
				.fail( function(xhr, textStatus, error) {
					//debug("EDITOR:checkExist:post(/checkExist/): DOESN'T EXIST!! ["+s+"]");
					//debug("EDITOR:checkExist:post(/checkExist/): failure xhr status=["+xhr.status+"]  responseText=["+xhr.responseText+"]");
					if( deferredErrorMsg ){
						showAlert(deferredErrorMsg);
						deferredErrorMsg = null;
					} else {
					}
					
				});
			}//checkExist
			function importtest(){
				//check if s exists on filesystem
				debug("EDITOR:importtest: enter");
				var obj={};
				obj.inputfile = "/Users/bradley_botkin/Documents/clips/foo.txt";
				$.post("/importtype/plain", { thedata: JSON.stringify(obj) }, function(temp) {
					
					
				})
				.fail( function(xhr, textStatus, error) {
					
				});
			}//checkExist

			
			
			function configCadet(){
				//debug("EDITOR:configCadet: enter");
				showConfigModal();
				//debug("EDITOR:configCadet: calling checkExists");
				//checkExists("/users/bradley_botkin/documents/cadet-versions/", null);
				//importtest()
				
			}//configCadet


			function openMediaFile(){
				showFileBrowserModal(DLG_MODE_OPEN, DISPATCH_OPEN_MEDIA, openMediaFromFile, null, "Open Media File", INCLUDE_MEDIA_MAP);  
			}//openMediaFile
			function openMediaFromFile(direct, smediadir, smediafile){
				//debug("EDITOR: openMediaFromFile: calling _fileBrowser.dumpPaths()");
				//_fileBrowser.dumpPaths();
				
				if( !LEAVE_CLEAN ){
					DIRTY = true; //project is changed...
					makeDirty(true);
				}
				LEAVE_CLEAN = false; //normally opening media sets dirty bits
				
				if( !direct ){	//via callback
					_mediaFilename = _fileBrowser.getWebFile();
					_mediaDir = _fileBrowser.getWebDir();
				} else {		//direct call with values
					_mediaFilename = smediafile;
					_mediaDir = smediadir;
				}
				//debug("EDITOR:openMediaFromFile file=["+_mediaFilename+"] dir=["+_mediaDir+"]");
				_cfg.setMediaInfo(_mediaFilename, _mediaDir);// also sets trackfilename and trackdir on config
				
				//adjust track file name
				var ttname;
				if( _mediaFilename.trim().length == 0 )
					ttname = "";
				else
					ttname = _mediaFilename.substring(0,_mediaFilename.lastIndexOf(".")) + ".temp.vtt";
				_trackFilename = ttname;

				/*
				//set up the player html
				var mediaUrl = "http://localhost:"+_cfg.port+_mediaDir+"/"+_mediaFilename
				debug("EDITOR: openMediaFromFile: mediaUrl=["+mediaUrl+"]");
				$("#cadetvideo")[0].src=mediaUrl; 
				var trk=$("#cadetvideo > track")[0];
				var trackUrl = "http://localhost:"+_cfg.port+_mediaDir+"/"+ttname
				trk.src=trackUrl;
				
				//UI mediaUrl
				_table.UIsetMedia(_webroot.replace(/\/+$/, "") + _mediaDir+"/"+_mediaFilename);
				*/
				
				_table.setupMediaPlayer(_cfg.port, _mediaDir, _mediaFilename);
				
				_table.setSelectionCurrentRowToBeginning();
				
				toggleAutoRefreshCaptions(true);

			}//openMediaFromFile
			
			function setMediaFromURL(s){
				var theurl = s;
				debug("EDITOR: setMediaFromURL ["+theurl+"]");
				_mediaFilename = theurl;
				//adjust track file name
				var ttname;
				ttname = theurl.substring(theurl.lastIndexOf("/"));
				ttname = ttname.substring(0,theurl.lastIndexOf(".")) + ".temp.vtt";
				debug("EDITOR: setMediaFromURL: ttname=["+ttname+"]");
				_trackFilename = ttname;
				
				//_cfg.mediaFilename = _mediaFilename;
				_cfg.setMediaFilename(_mediaFilename);	//also sets trackFilename
				//_cfg.setTrackFilename(ttname);
								
				//hard-coded to clips directory for now
				$("#cadetvideo")[0].src = theurl;  //fileURL;
				var trk=$("#cadetvideo > track")[0];
				trk.src="clips/"+ttname;  //fileURL;
				$('#mediaName').text("");	//thing next to button??
				//now extract and save the filename
				_mediaFilename = theurl;

			}
			
			function stopMedia(){
				var myVideo = $("#cadetvideo")[0];
				if(ableplayer === null) {
					myVideo.pause(); 
				}
				else {
					ableplayer.pauseMedia();
				}
			}//stopMedia
			
			function playPauseMedia(){
				var myVideo = $("#cadetvideo")[0];
				    //if( myVideo.paused ){
				    if( playerIsPaused() ){
				    
				    	if( _editMode == EDITMODE_REVIEW )
				    		cueIntime(_currentRow);
						if(ableplayer === null) {
							myVideo.play(); 						
						}
						else {
							ableplayer.playMedia();						
						}						
					} else {
						if(ableplayer === null) {
							myVideo.pause(); 
						}
						else {
							ableplayer.pauseMedia();
						}
					}

			}//playPauseMedia
			function playerIsPaused(){
				var ret = true;//defaults to true, in case there's no media loaded
				var myVideo = $("#cadetvideo")[0];
				    if( myVideo.paused ){
				    	ret = true;
					} else {
						ret = false; 
					}
				return ret;
			}//playerIsPaused
			function getMediaDuration(){
				var myvideo = $("#cadetvideo")[0];
				var dur = myvideo.duration;
				return(dur > 0.0 ? dur : INFINITY.timecodeToNumber());
			}//getMediaDuration
			function cueMedia(secs){
				//debug("EDITOR: cueMedia secs=["+secs+"]");
				var myVideo = $("#cadetvideo")[0];
				    myVideo.currentTime = secs; 
			}//cueMedia
			function mediaJump(bhow, inc){
				//debug("EDITOR: mediaJump forward=["+bhow+"] jump by=["+inc+"]");
				var myvideo = $("#cadetvideo")[0];
				if( !myvideo ) return;
				if( bhow )	//forward
					myvideo.currentTime = myvideo.currentTime + inc; //forward
				else		//reverse
					myvideo.currentTime = myvideo.currentTime - inc; //reverse
			}//mediaJump
		
			function toggleMode(){
				if( _editMode == EDITMODE_REVIEW ){
					document.getElementById("rbTranscribe").checked = true;
					_editMode = EDITMODE_TRANSCRIBE;
				} else {
					document.getElementById("rbReview").checked = true;
					_editMode = EDITMODE_REVIEW;
				}
			}//setEditmode
			
			function tryClear(){
				//warn and confirm
				confirm("Are you sure you want to clear all data?", clear, 400, 400);
			}//tryClear
			function clear(){
				//debug("EDITOR: clear");
				_data.clear();
				_table.clearAndLeaveSingle();
				DIRTY = true;
				makeDirty(true);
			}//clear
			
			function tryClearAllTimes(){
				//warn and confirm
				confirm("Are you sure you want to clear all timecodes?", clearAllTimes, 400, 400);
			}//tryClearAllTimes
			function clearAllTimes(){
				//debug("EDITOR: clearAllTimes");
				_table.clearAllTimes();
				DIRTY = true;
				makeDirty(true);
			}//clearAllTimes
			function clearCurrentTimes(){
				//debug("EDITOR: clearCurrentTimes");
				_table.clearCurrentTimes();
				DIRTY = true;
				makeDirty(true);
			}//clearCurrentTimes
			
			function tryClearOutTimes(){
				//warn and confirm
				confirm("Are you sure you want to clear all END timecodes?", clearOutTimes, 400, 400);
			}//tryClearOutTimes
			function clearOutTimes(){
				//debug("EDITOR: clearAllTimes");
				_table.clearOutTimes();
				DIRTY = true;
				makeDirty(true);
			}//clearOutTimes
			
			function deleteEvent() {
				if( _table.getRowCount() > 1 )
					if( bMarking && (markRow1>=0) && (markRow2>=0) ){
						//sort
						if( markRow2 < markRow1 ){
							var temp = markRow1;
							markRow1 = markRow2;
							markRow2 = temp;
						}
						var oldcurrow = markRow1;
					
						//delete the block of events
						for( var i=markRow1; i<=markRow2; i++ ){
							_table.deleteSomeEvent(markRow1);
						}
						
						//don't leave no rows
						if( _table.getRowCount() == 0 ){
							_table.clearAndLeaveSingle();
						}

					} else {
						_table.deleteEvent();	//shouldn't just delete the last row
					}
				else
					clear();	//clear and leave single
				DIRTY = true;
				makeDirty(true);
				return;
			}//deleteEvent
			
			function exportAll(){
				debug("EDITOR:ExportAll: ENTER");
				//_data.exportData();
			}//exportData
			
			
			function updateTable(){
				//update all table rows for intime, outtime, text
				debug("EDITOR: updateTable enter");
				
				for(var i=0; i<_data.events.length; i++){
					_tbodyElement.rows[i].cells[0].innerHTML = (i+1);
					_tbodyElement.rows[i].cells[1].innerHTML = _data.events[i].intime.toTimecode();
					_tbodyElement.rows[i].cells[2].innerHTML = _data.events[i].outtime.toTimecode();
					_tbodyElement.rows[i].cells[3].innerHTML = _data.events[i].textAsHtml();
				}

			}//updateTable
			
			function rebuildTable(){
				for(var i=0; i<_data.events.length; i++){
					_tbodyElement.rows[i].cells[0].innerHTML = (i+1);
					_tbodyElement.rows[i].cells[1].innerHTML = _data.events[i].intime().toTimecode();
					_tbodyElement.rows[i].cells[2].innerHTML = _data.events[i].outtime().toTimecode();
					_tbodyElement.rows[i].cells[3].innerHTML = _data.events[i].textAsHtml();
				}
			}//rebuildTable
			
			
			var nodeDepth=0, firstText=true;
			function buildStyleRuns(irow){
			
				//debug("*****************");
				//debug("CADET:buildStyleRun  innerHTML=["+_tbodyElement.rows[0].cells[3].innerHTML+"]");
				//debug("*****************");
				var cs = new CadetStyle();
				var sfoo = _table.getText(irow);
				//debug("CADET:buildStyleRun row=["+irow+"] text=["+sfoo+"]");
				
				var o=_tbodyElement.rows[irow].cells[3];
				//nodeDepth=0; firstText=true;
				
				//debug("*****************");
				//debug("CADET:buildStyleRun  innerHTML=["+_tbodyElement.rows[0].cells[3].innerHTML+"]");
				//debug("  Calling crawlCaptionNodes with innerHTML=["+_tbodyElement.rows[0].cells[3].innerHTML+"]");
				//debug("CADET:buildStyleRun  row=["+irow+"] initialStyle cs.getLinebreak()="+cs.getLinebreak()+"[]");
				//debug("*****************");
				crawlCaptionNodes(_tbodyElement.rows[irow].cells[3].firstChild, cs, irow);
				//debug("CADET:buildStyleRun table.getTextAlign=["+_table.getTextAlign()+"]");
				
				
			}//buildStyleRun
			
			function cleanupBlankLines(){
				//debug("DATA:cleanupBlankLines:  enter");
				var ievent, evcount=_data.getEvents().length;
				var ev;
				for(i=0; i<evcount; i++){
					ev = _data.getEvents()[i];
					var irun, runcount=0;
					
					if(ev.textRuns.length == 0) continue;
					
					//remove leading spaces from first run
					ev.textRuns[0].text = ev.textRuns[0].text.replace(/^\s+/,"");
					
					runcount = ev.textRuns.length;
					//debug("DATA:cleanupBlankLines:  runcount=["+ev.textRuns.length+"]");					
					trun = ev.textRuns[ev.textRuns.length-1];
					while ( evcount>1 && trun.linebreak ) {
						//remove the last textrun and reevaluate
						//debug("DATA:cleanupBlankLines:  about to remove trailing newline");
						ev.textRuns.pop();
						trun = ev.textRuns[ev.textRuns.length-1];
					}//each last linebreak
											
					
					
				}//each event
			}
		
			function crawlCaptionNodes(node,is, irow){ //"is" is initial style, a CadetStyle
				if( node == null ) return; //a totally empty cell, should never happen
			
				//<section>
				//	<b>
				//		<i>
				//			1
				//			<foo>
				//				bar
				//			</foo>
				//		</i>
				//	</b>
				//	2345
				//</section>
				var localname = node.nodeName;
			
				var sfoo;
				//debug("EDITOR:crawlCaptionNodes: ENTER nodeType=["+node.nodeType+"] with initial style=["+is.toString()+"]");
				//debug("EDITOR:crawlCaptionNodes: ENTER nodeType=["+node.nodeType+"] name=["+localname+"] with initial bold=["+is.getBold()+"]");
				
				//clone incoming style and use locally or pass along the chain: called "ls"
				var ls = new CadetStyle(is.getBold(),is.getItalic(),is.getUnderline(),is.getColor(),is.getBGColor(),is.getLinebreak());
				
				if( node.nodeType==3 ){//TEXT type node, so create a stylerun with the text and local style
					sfoo = node.nodeValue;
					//debug("EDITOR:crawlCaptionNodes: depth=["+nodeDepth+"] TEXT=["+sfoo+"] with current style=["+ls.toString()+"]");
					//debug("EDITOR:crawlCaptionNodes: textnode len=["+sfoo.length+"] val=["+sfoo+"]");
					
					//debug("DATA:crawlCaptionNodes: appending run with ["+sfoo+"] trimmed length=["+sfoo.trim().length+"] lastchar=["+sfoo.charCodeAt(sfoo.length-1)+"]");	
					if( sfoo.trim().length >= 0 ){
						//debug("DATA:crawlCaptionNodes: appending run text=["+sfoo+"] localstyle color=["+ls.color+"] bgcolor=["+ls.bgcolor+"] bold=["+ls.getBold()+"]");
						_data.getEvents()[irow].appendRun(sfoo, ls);
					}
					
				}
				else if( node.nodeType==1 && node.nodeName == "BR" ){
					//debug("EDITOR:crawlCaptionNodes: found BR setting LINEBREAK");
					//ls.setLinebreak(true);
					//debug("DATA:crawlCaptionNodes: set linebreak at BR");
					_data.getEvents()[irow].appendRun("", new CadetStyle(false,false,false,"","",true));//append a faux run to insert linebreak
				}
				else if( node.nodeType==1 && node.nodeName == "SECTION" ){
					//debug("EDITOR:crawlCaptionNodes: SECTION handle just like LINEBREAK, except on the first occurence");
					//if( !firstText )
					//	ls.setLinebreak(true);
					//firstText = false;
				}
				else if( node.nodeType==1 && node.nodeName == "DIV" ){
					//debug("EDITOR:crawlCaptionNodes: DIV handle just like LINEBREAK, except on the first occurence");
					//if( !firstText )
					//	ls.setLinebreak(true);
					//firstText = false;
					//ls.setLinebreak(true);
					//debug("DATA:crawlCaptionNodes: set linebreak at DIV");
					_data.getEvents()[irow].appendRun("", new CadetStyle(false,false,false,"","",true));//append a faux run to insert linebreak

				}
				else if( node.nodeType==1 && node.nodeName == "P" ){	//IE uses <P> elements as newlines
					//debug("EDITOR:crawlCaptionNodes: P handle just like LINEBREAK, except on the first occurence");
					//if( !firstText )
					//	ls.setLinebreak(true);
					//firstText = false;
					//debug("DATA:crawlCaptionNodes: set linebreak at P");
					_data.getEvents()[irow].appendRun("", new CadetStyle(false,false,false,"","",true));//append a faux run to insert linebreak
				}
				else if( node.nodeType==1 && ( node.nodeName == "B" || node.nodeName == "STRONG" ) ){
					//debug("TABLE:crawlCaptionNodes: set BOLD on local style");
					ls.setBold(true);
				}
				else if( node.nodeType==1 && ( node.nodeName == "I"|| node.nodeName == "EM") ){
					//debug("TABLE:crawlCaptionNodes: ITALIC");
					ls.setItalic(true);
				}
				else if( node.nodeType==1 && node.nodeName == "U" ){
					//debug("TABLE:crawlCaptionNodes: UNDERLINE");
					ls.setUnderline(true);
				}
				else if( node.nodeType==1 && node.nodeName == "SPAN" ){
					//debug("TABLE:crawlCaptionNodes: SPAN");
					if(node.style){
						var bgc = parseStyleFor( $(node).attr("style"), "background-color" );
						//debug("TABLE:crawlCaptionNodes: SPAN bgcolor=["+bgc+"]");
						ls.setBGColor(bgc);
					}
				}
				else if( node.nodeType==1 && node.nodeName == "FONT" ){
					//debug("TABLE:crawlCaptionNodes: FONT");
					var c = node.color;
					//debug("TABLE:crawlCaptionNodes: FONT color=["+c+"]");
					ls.setColor(c);
					//bgcolor
					if(node.style){
						var bgc = parseStyleFor( $(node).attr("style"), "background-color" );
						//debug("TABLE:crawlCaptionNodes: SPAN bgcolor=["+bgc+"]");
						ls.setBGColor(bgc);
					}
				}
				

				//for every child of this node
				var testcaseiterator = node.childNodes;				
				for(var i=0; i < testcaseiterator.length; i++){
					 crawlCaptionNodes(testcaseiterator[i], ls, irow);
				}
				 
				//when no more children, element must be done, unset it according to name
				if( localname == "B" || localname == "STRONG" ){
					//debug("TABLE:crawlCaptionNodes: unset BOLD on local style");
					ls.setBold(is.bold);
				}
				else if( localname == "I"|| localname == "EM" ){
					//debug("TABLE:crawlCaptionNodes: unset ITALIC on local style");
					ls.setItalic(is.italic);
				}
				else if( localname == "U" ){
					//debug("TABLE:crawlCaptionNodes: unset UNDERLINE on local style");
					ls.setUnderline(is.underline);
				}
				else if( localname == "SPAN" ){
					//debug("TABLE:crawlCaptionNodes: unset SPAN");
					if(node.style){
						var bgc = parseStyleFor( $(node).attr("style"), "background-color" );
						//debug("TABLE:crawlCaptionNodes: unset SPAN bgcolor=["+bgc+"]");
						ls.setBGColor(is.bgcolor);//("black");
					}
				}
				else if( localname == "FONT" ){
					//debug("TABLE:crawlCaptionNodes: unset FONT");
					var c = node.color;
					//debug("TABLE:crawlCaptionNodes: unset FONT color=["+c+"]");
					ls.setColor(is.color);//("white");
				}
						
				//debug("EDITOR:crawlCaptionNodes: EXIT nodeType=["+node.nodeType+"] with initial style=["+is.toString()+"]");

			}//crawlCaptionNodes
			
			/*
			*/
			function crawlCaptionNodesSave(node,is, irow){ //"is" is initial style, a CadetStyle
				if( node == null ) return; //a totally empty cell
				nodeDepth++;
				var sfoo;
				//debug("EDITOR:crawlCaptionNodes: ENTER nodeType=["+node.nodeType+"] with initial style=["+is.toString()+"]");
				debug("EDITOR:crawlCaptionNodes: ENTER nodeType=["+node.nodeType+"] with initial bold=["+is.getBold()+"]");
				
				//clone incoming style and use locally or pass along the chain: called "ls"
				var ls = new CadetStyle(is.getBold(),is.getItalic(),is.getUnderline(),is.getColor(),is.getBGColor(),is.getLinebreak());
				if( node.nodeType==3 ){//TEXT type node, so create a stylerun with the text and local style
					firstText = false
					sfoo = node.nodeValue;
					//debug("EDITOR:crawlCaptionNodes: depth=["+nodeDepth+"] TEXT=["+sfoo+"] with current style=["+ls.toString()+"]");
					debug("EDITOR:crawlCaptionNodes: textnode len=["+sfoo.length+"] val=["+sfoo+"]");
					
					//debug("DATA:crawlCaptionNodes: appending run with ["+sfoo+"] trimmed length=["+sfoo.trim().length+"] lastchar=["+sfoo.charCodeAt(sfoo.length-1)+"]");	
					if( sfoo.trim().length >= 0 ){
						debug("DATA:crawlCaptionNodes: appending run text=["+sfoo+"] localstyle color=["+ls.color+"] bgcolor=["+ls.bgcolor+"] bold=["+ls.getBold()+"]");
						_data.getEvents()[irow].appendRun(sfoo, ls);
					}
					sfoo = sfoo;
					
					if( nodeDepth==2 ){
					}
						//reset the localstyle colors to original after each text node
						//ls = new CadetStyle(is.getBold(),is.getItalic(),is.getUnderline(),is.getColor(),is.getBGColor(),is.getLinebreak());
						debug("DATA:crawlCaptionNodes: resetting to initial style color=["+is.color+"] bgcolor=["+is.bgcolor+"] bold=["+is.getBold()+"]");
						ls.setColor(is.color);
						ls.setBGColor(is.bgcolor);
						ls.setBold(is.getBold());
				}
				else if( node.nodeType==1 && node.nodeName == "BR" ){
					//debug("EDITOR:crawlCaptionNodes: LINEBREAK");
					ls.setLinebreak(true);
				}
				else if( node.nodeType==1 && node.nodeName == "SECTION" ){
					//debug("EDITOR:crawlCaptionNodes: SECTION handle just like LINEBREAK, except on the first occurence");
					//if( !firstText )
					//	ls.setLinebreak(true);
					firstText = false;
				}
				else if( node.nodeType==1 && node.nodeName == "DIV" ){
					//debug("EDITOR:crawlCaptionNodes: DIV handle just like LINEBREAK, except on the first occurence");
					//if( !firstText )
					//	ls.setLinebreak(true);
					firstText = false;
				}
				else if( node.nodeType==1 && node.nodeName == "P" ){	//IE uses <P> elements as newlines
					//debug("EDITOR:crawlCaptionNodes: P handle just like LINEBREAK, except on the first occurence");
					//if( !firstText )
					//	ls.setLinebreak(true);
					firstText = false;
				}
				else if( node.nodeType==1 && ( node.nodeName == "B" || node.nodeName == "STRONG" ) ){
					debug("TABLE:crawlCaptionNodes: set BOLD on local style");
					ls.setBold(true);
				}
				else if( node.nodeType==1 && ( node.nodeName == "I"|| node.nodeName == "EM") ){
					//debug("TABLE:crawlCaptionNodes: ITALIC");
					ls.setItalic(true);
				}
				else if( node.nodeType==1 && node.nodeName == "U" ){
					//debug("TABLE:crawlCaptionNodes: UNDERLINE");
					ls.setUnderline(true);
				}
				else if( node.nodeType==1 && node.nodeName == "SPAN" ){
					//debug("TABLE:crawlCaptionNodes: SPAN");
					if(node.style){
						var bgc = parseStyleFor( $(node).attr("style"), "background-color" );
						//debug("TABLE:crawlCaptionNodes: SPAN bgcolor=["+bgc+"]");
						ls.setBGColor(bgc);
					}
				}
				else if( node.nodeType==1 && node.nodeName == "FONT" ){
					//debug("TABLE:crawlCaptionNodes: FONT");
					var c = node.color;
					//debug("TABLE:crawlCaptionNodes: FONT color=["+c+"]");
					ls.setColor(c);
				}
				
				if (node.firstChild) {
					crawlCaptionNodes(node.firstChild, ls, irow);
				}				
			
				if (node.nextSibling) {
					crawlCaptionNodes(node.nextSibling, ls, irow);
				}
						
				//debug("EDITOR:crawlCaptionNodes: EXIT nodeType=["+node.nodeType+"] with initial style=["+is.toString()+"]");
				nodeDepth--;

			}//crawlCaptionNode Save
			
			function parseStyleFor(cssstyle, sattr){
				if( !cssstyle ) return "";
				var ar1, ar2, sfoo, sfoo2;
				ar1 = cssstyle.split(";");
				for( var i=0; i<ar1.length; i++ ){
					sfoo = ar1[i];
					if( sfoo.indexOf(sattr) >= 0 ){
						ar2=sfoo.split(":");
						var newstr = ar2[1];
						//if in the form of "rgb(x, y, z)" then convert to "#rrggbb"
						if( newstr.indexOf("rgb(") > -1 ){
							var re=/rgb\((\w+),(\w+),(\w+)/;
							newstr = ar2[1].replace(re, '#'+intToHex($1)+intToHex($2)+intToHex($3));
						}
						
						//return(ar2[1].trim());
						return(newstr.trim());
					}
				}
				return("");
			}//parseStyleFor
			function intToHex(i, padding) {
				var hex = i.toString(16);
				padding = typeof (padding) === "undefined" || padding === null ? padding = 2 : padding;

				while (hex.length < padding) {
					hex = "0" + hex;
				}

				return hex;
			}
			
			//////////////////////////////////////////////////
			//	doSaveProject
			//	Save event data
			//////////////////////////////////////////////////
			function doSaveProject(){
				//debug("CADET:doSaveProject: ENTER");
			
				if( (_cfg.webProjectFile == DEFAULT_WEBPROJECT_FILE) || (_cfg.webProjectFile.trim().length == 0) ){
					showFileBrowserModal(DLG_MODE_SAVE, DISPATCH_SAVE_PROJECT, saveProject, _cfg.webProjectFile, "Save Project", INCLUDE_PROJECT_MAP);  
				} else {
					saveProject(true);
				}
			}//doSaveProject
			function saveProject(direct){
				//debug("CADET:saveProject: ENTER");
				
				if( !direct ){	//came through dialog, so capture dialog settings
					//_fileBrowser.dumpPaths();
					var sfoo = _fileBrowser.getWebFile();
					if( !sfoo.endsWith(DEFAULT_CADET_EXTENTION) )
						sfoo += DEFAULT_CADET_EXTENTION;
				_cfg.setWebProject(_fileBrowser.getWebDir(), sfoo);
				}
						
				
				if( !_mediaFilename ){
					//debug("CADET:saveProject: no media selected, might want to exit??");
								//return;
				} else {
					//debug("CADET:saveProject: _mediaFilename=["+_mediaFilename+"] _mediaUriDir=["+_mediaUriDir+"]");
				}
				
				
				//convert table data to event data
				//debug("CADET:saveProject: calling table.tableToEvents");
				//_data = _table.tableToEvents();
				
				//clear the data structure
				_data.clear();
				
				//debug("CADET:saveProject: _table.getLength=["+_table.getLength()+"]");
				//for each table rows, add an event with runs
				
				//update tbodyelement reference
				_tbodyElement = $table.children('tbody')[0];
				for( var i=0; i<_table.getLength(); i++ ){
					//make sure there's an event there
					_data.addEvent(i, _table.getIntime(i).timecodeToNumber(), _table.getOuttime(i).timecodeToNumber(), _table.getText(i), _table.getHtmlText(i));
					//stuff the event with the table's html
					//debug("CADET:saveProject: htmltext from TABLE=["+_table.getHtmlText(i)+"]");
					//_data.getEvents()[i].setHtmlText(_table.getHtmlText(i));
					
					buildStyleRuns(i);
					//and save alignment here, because it's not trapped within the html yet.
					_data.events[i].setTextAlign(_table.getTextAlign(i));
					
					//debug("CADET:saveProject: event#"+i+" has ["+_data.getEvents()[i].textRuns.length+"] runs");
				}
				
				/*
				//clean up style runs, deleting trailing linebreaks
				for( var i=0; i<_table.getLength(); i++ ){
					//make sure there's an event there
					var ev=_data.events[i];
					
					if( ev.textRuns.length > 0 )
						if( ev.textRuns[ev.textRuns.length-1].linebreak )
							ev.textRuns.splice(ev.textRuns.length-1,1);
					
				}
				*/

				//debug("CADET:saveProject: sending POST");
				
				//_data.setMediaFilename(_mediaFilename);	//side-effect also sets _trackFilename
				//_data.setTrackFilename(_trackFilename);
				getReadyForExport();
				
				//debug("CADET:saveData: stringify(_data)=["+JSON.stringify(_data)+"]");
				this.data = _data;
				$.post("/saveproject/", { thedata : JSON.stringify(_data) }, function(temp) {
					// temp === "I am done";  
					//debug("CADET:saveProject: success response=["+temp+"]");
					//debug("CADET:saveProject: success _cfg.getWebFile=["+_cfg.webProjectFile+"]");
					
					//update UI project file
					//$("#projectFile").text(_webroot.replace(/\/+$/, "") + _cfg.webProjectDir + "/" + _cfg.webProjectFile);
					_table.UIsetProjectFile(_webroot.replace(/\/+$/, "") + _cfg.webProjectDir + "/" + _cfg.webProjectFile);
					
					
					//refreshCaptions();
					doStatus(temp);
					DIRTY = false;
					makeDirty(false);

				})
				.fail( function(xhr, textStatus, error) {
					debug("CADET:saveProject: failure xhr status=["+xhr.status+"]  responseText=["+xhr.responseText+"]");
					showAlert("CADET:saveProject: failure xhr status=["+xhr.status+"]  responseText=["+xhr.responseText+"]");
				});
				
				
			}//saveProject
			
			function doExport(){
				//first make sure there's text to export
				if( !checkForText() ){
					showAlert("There's no text to export!", 600, 600);
					return;
				}
			
			}//doExport
			function doExportWhere(){
				//debug("EDITOR:doExportWhere: ENTER");
				//return;
				
				//first make sure there's text to export
				if( !checkForText() ){
					showAlert("There's no text to export.", 600, 600);
					return;
				}
								
				var exportFilename;
				
				exportFilename = _fileBrowser ? _fileBrowser.getExportFile() : "";
				if( exportFilename == "" ){
					if( _data.config.mediaFilename )
						exportFilename = _data.config.mediaFilename;
					else
						exportFilename = "untitled";
				}
								
				showFileBrowserModal(DLG_MODE_SAVE_TYPE, DISPATCH_NONE, exportWhere, exportFilename, "Export Timed-Text File", INCLUDE_MAP_IN_USE);  
				return;
			}//doExportWhere
			
			function exportWhere(direct){
				var dir, file, etype;
				dir = _fileBrowser.getWebDir();
				file = _fileBrowser.getWebFile();
				etype = _fileBrowser.getExportType();
				//alert("CADET:exportWhere: ENTER dir=["+dir+"] file=["+file+"] type=["+etype+"]");
				
				//check timecodes except for plaintext
				if( etype != EXPORT_TYPE_PLAIN ){
					doStatus("CHECKING TIMECODES:",true);
					if( !checkTimecodes() ){
						showAlert("Timecode sequencing problems detected, see error links in status box.", 600, 600);
						return;
					}
					doStatus("Timecodes OK");
				}
				
				_data.config.setExportCoords(dir, file, etype);
				exportDataAs(etype);
			}//exportWhere
						
			function exportDataAs(etype){
				debug("EDITOR:exportDataAs: ENTER with etype=["+etype+"]");
				
				if( !_mediaFilename ){
					debug("CADET:exportDataAs: no such _mediaFilename");
					//return;
				} else {
					debug("CADET:exportDataAs: _mediaFilename=["+_mediaFilename+"] _mediaUriDir=["+_mediaUriDir+"]");
				}
													
				//clear the data structure
				_data.clear();
								
				//update tbodyelement reference
				_tbodyElement = $table.children('tbody')[0];
				for( var i=0; i<_table.getLength(); i++ ){
					_data.addEvent(i, _table.getIntime(i).timecodeToNumber(), _table.getOuttime(i).timecodeToNumber(), _table.getText(i), _table.getHtmlText(i));
				
					buildStyleRuns(i);
				
					//and save alignment here, because it's not trapped within the html yet.
					_data.events[i].setTextAlign(_table.getTextAlign(i));
				}
				
				//remove elements that don't have timecodes (except for PlainTextExport, from the bottom up
				if( etype != EXPORT_TYPE_PLAIN ){
					//remove elements that don't have intimes, and fix up outtimes... from the bottom up
					var len = _table.getLength();
					for( var i=len-1; i>=0; i-- ){
				
						if( _data.getIntime(i) == -1 ){
							_data.deleteEvent(i,1);
						} else if(_data.getOuttime(i) == -1){ //check for implicit outtimes
							//debug("CADET:exportDataAs: outtime at i=["+i+"] was blank");
							if( i == _data.getLength()-1 ){//last in table, make media duration
								//debug("CADET:exportDataAs: it was last in table, set to media length=["+getMediaDuration()+"]");
								_data.setOuttime(i, getMediaDuration())
							} else {	//make outtime the next intime minus blinktime
								//debug("CADET:exportDataAs: normal, set to next intime");
								_data.setOuttime(i, _data.getIntime(i+1) - MIN_BLINK_TIME)
							}
					
						}
					}
					//check to make sure there's something left to export
					if( _data.getEvents().length == 0 ){
						alert("Sorry, there are no timecoded events to export.");
						return;
					}
				}

				getReadyForExport();
				if( !_data.config.mediaFilename ){
					//debug("CADET:exportDataAs: checking config: nothing but continuing");
					//return;
				}
				
				//debug("CADET:exportDataAs: sending POST");
				this.data = _data;
				doStatus("Exporting to file type=["+etype+"]. Please wait...");
				$.post("/exporttype/"+etype, { thedata : JSON.stringify(_data) }, function(temp) {
					//debug("CADET:exportDataAs: success response=["+temp+"]");
					showAlert(temp,600,600);
					doStatus(temp);
					return;

				})
				.fail( function(xhr, textStatus, error) {
					debug("CADET:exportDataAs: failure xhr.status=["+xhr.status+"]");
					debug("CADET:exportDataAs: failure xhr.responseText=["+xhr.responseText+"]");
				});
				
			}//exportDataAs
			
			var fromItype;
			var fileinfo={};
			function importDataFrom(itype){
				fromItype = itype
				var includemap;
				switch (fromItype) {
					case IMPORT_TYPE_PLAIN:							
						includemap = INCLUDE_PLAINTEXT_MAP;
						break;
						
					case IMPORT_TYPE_VTT:
						includemap = INCLUDE_VTT_MAP;
						break;
						
					case IMPORT_TYPE_SRT:
						includemap = INCLUDE_SRT_MAP;
						break;
						
					case IMPORT_TYPE_TTML:
						includemap = INCLUDE_TTML_MAP;
						break;
						
					case IMPORT_TYPE_QTTEXT:
						includemap = INCLUDE_QTTEXT_MAP;
						break;
						
					case IMPORT_TYPE_SAMI:
						includemap = INCLUDE_SAMI_MAP;
						break;
						
					default:
						includemap = INCLUDE_ALL_MAP
						break;
				}					
				
				//debug("EDITOR:importDataFrom: ENTER with fromItype=["+fromItype+"]");
				showFileBrowserModal(DLG_MODE_OPEN, DISPATCH_OPEN_PROJECT, importDataFromType, null, "Import File", includemap);  //"*" means all files, no filtering
			}//importDataFrom
			
			// record start time
			var perfStartTime;
			var perfEndTime;
			function itoeTimeDiff(startTime,endTime){
				// time difference in ms
				var timeDiff = endTime - startTime;
				// strip the ms
				timeDiff /= 1000;
				// get seconds (Original had 'round' which incorrectly counts 0:28, 0:29, 1:30 ... 1:59, 1:0)
				var seconds = Math.round(timeDiff % 60);
				// remove seconds from the date
				timeDiff = Math.floor(timeDiff / 60);
				// get minutes
				var minutes = Math.round(timeDiff % 60);
				// remove minutes from the date
				timeDiff = Math.floor(timeDiff / 60);
				// get hours
				var hours = Math.round(timeDiff % 24);
				// remove hours from the date
				timeDiff = Math.floor(timeDiff / 24);
				// the rest of timeDiff is number of days
				var days = timeDiff ;
				return(pad(hours,2)+":"+pad(minutes,2)+":"+pad(seconds,2));			
			}//itoeTimeDiff
			function pad(num, size) {
				var s = num+"";
				while (s.length < size) s = "0" + s;
				return s;
			}//pad

			function importDataFromType(){
				//debug("EDITOR:importDataFromType: ENTER with fromItype=["+fromItype+"]");
				
				fileinfo.filename = _fileBrowser.getWebFile();											
				fileinfo.dir = _fileBrowser.getWebDir();
				var sfileinfo = JSON.stringify(fileinfo);											
				doStatus("Importing from file=["+fileinfo.filename+"] type=["+fromItype+"].");
				doStatus("This could take a moment, please wait...");
				perfStartTime = new Date();

				$.post("/importtype/"+fromItype, { thedata : sfileinfo }, function(temp) {
					
					switch (fromItype) {
						case IMPORT_TYPE_PLAIN:							
							var thedata = JSON.parse(temp).data;
							//debug("EDITOR:importDataAs:post(/importtype/):VTT success lines=["+JSON.stringify(thedata,null,2)+"]");
							dataToTable(thedata, fromItype);
							break;
							
						case IMPORT_TYPE_VTT:
							var thedata = JSON.parse(temp).data;
							//debug("EDITOR:importDataAs:post(/importtype/):VTT success lines=["+JSON.stringify(thedata,null,2)+"]");
							dataToTable(thedata, fromItype);
							break;
							
						case IMPORT_TYPE_SRT:
							var thedata = JSON.parse(temp).data;
							//debug("EDITOR:importDataAs:post(/importtype/):VTT success lines=["+JSON.stringify(thedata,null,2)+"]");
							dataToTable(thedata, fromItype);
							break;
							
						case IMPORT_TYPE_TTML:
							var thedata = JSON.parse(temp).data;
							//var d = new Date();
							//debug("EDITOR:importDataAs: calling dataToTable mm:ss=["+d.getMinutes()+":"+d.getSeconds()+"]");
							//debug("EDITOR:importDataAs:post(/importtype/):VTT success lines=["+JSON.stringify(thedata,null,2)+"]");
							dataToTable(thedata, fromItype);
							//d = new Date();
							//debug("EDITOR:importDataAs: finished dataToTable mm:ss=["+d.getMinutes()+":"+d.getSeconds()+"]");
							break;
							
						case IMPORT_TYPE_QTTEXT:
							//alert("Import from QTtext not yet implemented");
							//doStatus("Import from QTtext not yet implemented.");
							//return;
							var thedata = JSON.parse(temp).data;
							//debug("EDITOR:importDataAs:post(/importtype/):VTT success lines=["+JSON.stringify(thedata,null,2)+"]");
							dataToTable(thedata, fromItype);
							break;
							
						default:
							//showAlert("EDITOR:importDataAs:post(/importtype/):default should never get here]");
							//return;
							break;
					}					
					
					
					//debug("EDITOR:importDataFromType: success response=["+temp+"]");
					//showAlert(temp);
					refreshCaptions(true);//force a refresh
					doStatus("Import from file=["+fileinfo.filename+"] type=["+fromItype+"] complete.");
					perfEndTime = new Date();
					doStatus("Elapsed time=["+itoeTimeDiff(perfStartTime, perfEndTime)+"]");

					DIRTY = true;
					makeDirty(true);
					return;
				})

				.fail( function(xhr, textStatus, error) {
					debug("EDITOR:importDataFromType:post(/importtype/): failure xhr status=["+xhr.status+"]  responseText=["+xhr.responseText+"]");
					showAlert(xhr.responseText);//"EDITOR:importDataFromType:post(/importtype/): failure");
					doStatus("!! Failed to import !! ");

				});
				
			}//importDataFromType
			function lineArrayToData(thedata){
				return;
			}//lineArrayToData
			function dataToTable(thedata, fromItype){
				//debug("EDITOR:dataToTable enter with fromItype=["+fromItype+"] thedata=["+JSON.stringify(thedata,null,2)+"]");
				
				//hide the table
				//var oldtabledisplay = $("#divtable").css("display");
				//$("#divtable").css("display","none");
				var oldtablevisibility = $("#divtable").css("visibility");
				$("#divtable").css("visibility","hidden");
				
				/*
				var whichway = "before"
				//check for blank table (1 row, no text content)
				//debug("EDITOR:dataToTable: rowcount=["+_table.getRowCount()+"]");
				
				if( (_table.getRowCount() == 1) && (_table.getText(0).trim().length==0) ){
					debug("whichway is clearing table");
					//_table.clear();
					//whichway = "after"
				}
				*/
				
				var oldcurrow = _table.getCurrentRow();
				var newcurrow = oldcurrow;
				var sfoo;
				var events = thedata.events;
				var someevent;
				SCREEN_REFRESH_ON = false;
				for(var i=0; i<events.length; i++){
					doStatus("Processing event #"+(i+1));
					someevent = events[i];
					//debug("***EDITOR:dataToTable SOMEEVENT=["+JSON.stringify(someevent,null,2)+"]");
					
					//inserts file ABOVE current row
					//!!!!!!!!!!!!! addRowAt is the slowdown !!!!!!!!!!!!!!
					addRowAt(newcurrow, someevent.intime, someevent.outtime, " ");
					setCurrentRow(newcurrow);
															
					
					//now build up the text from textRuns
					/*
					var tr;
					var numruns=events[i].textRuns.length;
					shtml = "";
					for(var j=0; j<numruns; j++){
						tr = someevent.textRuns[j];
						//debug("***EDITOR:dataToTable TR=["+JSON.stringify(tr,null,2)+"]");
						if( tr.style.linebreak ){
							document.execCommand('insertParagraph',false)
						} else {
							//insert the text()
							//debug("***EDITOR:dataToTable TR.TEXT=["+tr.text+"]");
							document.execCommand("insertText",false,tr.text)
						}
					}
					*/
					//using execCommand seems to incur huge delays, so bang the <section> HTML directly
					//now build up the html from textRuns (just doing text for now, handle styles in later rev.)
					var tr;
					var numruns=events[i].textRuns.length;
					var shtml = "";
					for(var j=0; j<numruns; j++){
						tr = someevent.textRuns[j];
						if( tr.style.linebreak ){
							shtml += "<br>";
						} else {
							//insert the text(), handle styles in later rev.
							shtml += tr.text;
						}
					}
					//wrap html text in font tag to get colors
					shtml = "<font color='"+DEFAULT_FORECOLOR+"' style='background-color: "+DEFAULT_BACKCOLOR+";'>" + shtml + "</font>";
					
					_table.setSectionHtml(newcurrow,shtml);
					
					//setCurrentRow(newcurrow+1);
					setCurrentRow(newcurrow+1);
					newcurrow = _table.getCurrentRow();
					
				}
				SCREEN_REFRESH_ON = true;

				_table.updateRowNumbers();
				_table.setCurrentRow(oldcurrow);
				_table.setSelectionCurrentRowToBeginning()
		
				//show the table
				//$("#divtable").css("display",oldtabledisplay);
				$("#divtable").css("visibility",oldtablevisibility);
				
				//focus the caption content
				_table.focusCaptionCell(oldcurrow);

				return;
			}//dataToTable
			
			function editFind(){
				//doStatus("Edit/Find not yet implemented.")
				//debug("Edit/Find not yet implemented.")
				//return;
				//findText("foo", 0, true);
				
				//clear the data structure
				_data.clear();
								
				//update tbodyelement reference
				_tbodyElement = $table.children('tbody')[0];
				for( var i=0; i<_table.getLength(); i++ ){
					_data.addEvent(i, _table.getIntime(i).timecodeToNumber(), _table.getOuttime(i).timecodeToNumber(), _table.getText(i), _table.getHtmlText(i));
				
					buildStyleRuns(i);
				
					//and save alignment here, because it's not trapped within the html yet.
					_data.events[i].setTextAlign(_table.getTextAlign(i));
				}
				getReadyForExport();
				
				//showFind("" ,600,300, _table.getCurrentRow(), this, _table);
				showFind("" ,600,300, _table.getCurrentRow(), _data, _table);
			}//editFind
			
			function findText( starget, irow, icol, bcaseinsensitive ){
				
				//convert table data to internal array of events with styleRuns
				debug("EDITOR:findText: starg=["+starget+"] row=["+irow+"] col=["+icol+"] case=["+bcaseinsensitive+"]");
				
				//clear the data structure
				_data.clear();
				//update tbodyelement reference
				_tbodyElement = $table.children('tbody')[0];
				for( var i=0; i<_table.getLength(); i++ ){
					_data.addEvent(i, _table.getIntime(i).timecodeToNumber(), _table.getOuttime(i).timecodeToNumber(), _table.getText(i), _table.getHtmlText(i));
				
					buildStyleRuns(i);
				
					//and save alignment here, because it's not trapped within the html yet.
					_data.events[i].setTextAlign(_table.getTextAlign(i));
				}
				
				//now find the first occurence of starget, starting at the irow'th event
				var starg = starget;
				if( bcaseinsensitive ) starg = starg.toLowerCase();
				var o = {found:false, target:starget, caseinsensitive:bcaseinsensitive };
				debug("EDITOR:findText: target=["+starg+"]");
				for( var i=irow; i<_data.events.length; i++ ){
					var stext = _data.events[i].text;
					if( bcaseinsensitive ) stext = stext.toLowerCase();
					debug("EDITOR:findText: event=["+i+"] text=["+stext+"]");
					if( stext.indexOf(starg) >= 0 ){	//got a match
						debug("EDITOR:findText: MATCH! event=["+i+"] stext=["+stext+"] starg=["+starg+"]");
						//setCurrentRow(i);
						o.row = i;
						o.col = stext.indexOf(starg);
						o.eventtext = _data.events[i].text;
						o.found = true
						return( o );
					}
				}
				
				debug("DATA:findText: NO FIND!");
				return o;
				
			}//findText
			
			function editReplace(){
				doStatus("Edit/Replace not yet implemented.")
				debug("Edit/Replace not yet implemented.")
				return;
				debug("DATA:editReplace: enter");
				debug("DATA:editReplace: exit");
			}//editFind

			
			//////////////////////////////////////////////////
			//	refreshCaptions
			//	Refresh the (temp) caption file
			//////////////////////////////////////////////////
			function refreshCaptions(force){
				if( force )
					refreshing = false;
					
				if( refreshing ){
					//debug("refreshing already, not re-entrant");
					return; //not re-entrant
				}
				//debug("CADET:refreshCaptions: ENTER");
				
				if( !_mediaFilename || _mediaFilename.length==0 ){
					//debug("CADET:refreshCaptions: no media selected, exiting");
					return;
				} else {
				}
				//debug("CADET:refreshCaptions: _mediaFilename=["+_mediaFilename+"] _mediaUriDir=["+_mediaUriDir+"]");
				
				refreshing = true;
									
				//clear the data structure
				_data.clear();
								
				//update tbodyelement reference
				_tbodyElement = $table.children('tbody')[0];
				for( var i=0; i<_table.getLength(); i++ ){
					//make sure there's an event there
					_data.addEvent(i, _table.getIntime(i).timecodeToNumber(), _table.getOuttime(i).timecodeToNumber(), _table.getText(i), _table.getHtmlText(i));
					//stuff the event with the table's html
					//debug("CADET:saveData: htmltext from TABLE=["+_table.getHtmlText(i)+"]");
					//_data.getEvents()[i].setHtmlText(_table.getHtmlText(i));
					buildStyleRuns(i);
					//and save alignment here, because it's not trapped within the html yet.
					_data.events[i].setTextAlign(_table.getTextAlign(i));
				
					//debug("CADET:saveData: event#"+i+" has ["+_data.getEvents()[i].textRuns.length+"] runs");
				}
				
				//remove elements that don't have intimes, and fix up outtimes... from the bottom up
				var len = _table.getLength();
				for( var i=len-1; i>=0; i-- ){
				
					if( _data.getIntime(i) == -1 ){
						_data.deleteEvent(i,1);
					} else if(_data.getOuttime(i) == -1){ //check for implicit outtimes
						//debug("CADET:refreshCaptions: outtime at i=["+i+"] was blank");
						if( i == _data.getLength()-1 ){//last in table, make media duration
							//debug("CADET:refreshCaptions: it was last in table, set to media length=["+getMediaDuration()+"]");
							_data.setOuttime(i, getMediaDuration())
						} else {	//make outtime the next intime minus blinktime
							//debug("CADET:refreshCaptions: normal, set to next intime");
							_data.setOuttime(i, _data.getIntime(i+1))
						}
					
					}
				}
				

				//debug("CADET:refreshCaptions: sending POST");
				
				getReadyForExport();
				
				this.data = _data;
				var foo1 = JSON.stringify(_data);
				
				
				$.post("/refreshCaptions/", { thedata : JSON.stringify(_data) }, function(temp) {
					//debug("CADET:saveData: success response=["+temp+"]");
					$("#cadetvideo > track").remove(); //blow away all track elements
					track = document.createElement("track");	//create track element
					//set some attributes
					track.kind = "captions"; 
					track.label = "Captions"; 
					track.srclang = "en"; 
					track.default = "true";
					
					//track.src = "http://localhost:8000/clips/barstone.temp.vtt?"+Math.random();
					//track.src = "http://localhost:"+_cfg.port+_mediaDir+"/"+_trackFilename+"?"+Math.random();
					track.src = _mediaDir+"/"+_trackFilename+"?"+Math.random();
					
					//debug("EDITOR:refreshCaptions: adding eventListener for track load");
					track.addEventListener("load", function() { 
						this.mode = "showing"; 
						$("#cadetvideo")[0].textTracks[0].mode = "showing"; // thanks Firefox 
						//debug("EDITOR: saveData: FIREFOX set track showing");
						
						//Goose for FIREFOX, which only updates screen during play/scrub
						var v=$("#cadetvideo")[0];
						if(v && playerIsPaused()){
							var oldtime = $("#cadetvideo")[0].currentTime;
							$("#cadetvideo")[0].currentTime = oldtime + 0.1;
							$("#cadetvideo")[0].currentTime = oldtime;
						}
						
						//window.clearInterval(intervalRefresh);	
						//intervalRefresh = null;
						toggleAutoRefreshCaptions(false);
					});					
					$("#cadetvideo")[0].appendChild(track);
					
					refreshing = false;
					return;

				})
				.fail( function(xhr, textStatus, error) {
					debug("CADET:refreshCaptions: failure xhr.status=["+xhr.status+"]");
					debug("CADET:refreshCaptions: failure xhr.responseText=["+xhr.responseText+"]");
					refreshing = false;
				});
				
				
			}//refreshCaptions
			
			function toggleAutoRefreshCaptions(on){ //true turns it on, false turns it off
				if( !_mediaFilename ){
					//debug("EDITOR:toggleAutoRefreshCaptions NO MEDIA!!");
					//return;
				} else {
					//debug("EDITOR:toggleAutoRefreshCaptions turning ["+on+"]");
				}

				if( on ){
					if( !intervalRefresh )
						intervalRefresh = setInterval(refreshCaptions, refreshDelay);
				} else {
					window.clearInterval(intervalRefresh);	
					intervalRefresh = null;
				}
			}//toggleAutoRefreshCaptions
			
			//////////////////////////////////////////////////
			//	exportQTtext
			//	Export in QTtext format
			//////////////////////////////////////////////////
			function exportQTtext(){
				debug("CADET:exportQTtext: ENTER");
								
				//clear the data structure
				_data.clear();
				
				//update tbodyelement reference
				_tbodyElement = $table.children('tbody')[0];
				for( var i=0; i<_table.getLength(); i++ ){
					//make sure there's an event there
					_data.addEvent(i, _table.getIntime(i).timecodeToNumber(), _table.getOuttime(i).timecodeToNumber(), _table.getText(i), _table.getHtmlText(i));
					
					buildStyleRuns(i);
					//and save alignment here, because it's not trapped within the html yet.
					_data.events[i].setTextAlign(_table.getTextAlign(i));
					
					//debug("CADET:saveData: event#"+i+" has ["+_data.getEvents()[i].textRuns.length+"] runs");
				}

				debug("CADET:exportQTtext: sending POST");
				
				//_data.setMediaFilename(_mediaFilename);	//side-effect also sets _trackFilename
				//_data.setTrackFilename(_trackFilename);
				//_fileBrowser.dumpPaths();
				_cfg.setWebProject( _fileBrowser.getWebDir(), _fileBrowser.getWebFile() );
				getReadyForExport();
				debug("CADET:exportQTtext: stringify(_cfg)=["+JSON.stringify(_cfg)+"]");
				
				debug("CADET:exportQTtext: stringify(_data)=["+JSON.stringify(_data)+"]");
				this.data = _data;
				$.post("/export/qttext/", { thedata : JSON.stringify(_data) }, function(temp) {
					// temp === "I am done";  
					debug("CADET:exportQTtext: success response=["+temp+"]");
					//reset the track file on the mediaDir
					//var trk=$("video > track")[0];
					//trk.src=""; //unset it
				})
				.fail( function(xhr, textStatus, error) {
					debug("CADET:exportQTtext: failure xhr .status=["+xhr.status+"]  .responseText=["+xhr.responseText+"]");
				});
				
				
			}//exportQTtext
						
			//window.clearInterval(intervalRefresh);			
			//intervalRefresh = setInterval(refreshCaptions, refreshDelay);
			
			//doesn't seem to work to initialize
			//debug("CADET:constructor bottom: ui set projfile=["+_webroot.replace(/\/+$/, "") + _cfg.webProjectDir + "/" + _cfg.webProjectFile+"]");
			_table.UIsetProjectFile(_webroot.replace(/\/+$/, "") + _cfg.webProjectDir + "/" + _cfg.webProjectFile);

			return( this );

		} // CadetEditor Module constructor

//	}); // ready


}) (); // CadetEditor

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
//
//	C a d e t D a t a
//
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
(function  () {

//	$(document).ready (function () {


		var moduleName = "CadetData"; // constructor
		var instanceCount = 0;

		// here we assign the constructor to the global variable, but we could assign an instance if we wanted to provide a singleton
		var module = window[moduleName] = Module;

		/*
			function Module (userOptions) {
			var options = {
				_theTable: null,
			}; // defaults
			//options = _.extend (options, userOptions);
		*/	
	
		function Module (cfg) {
			/// PRIVATE INSTANCE VARIABLES	
			//var foo = "bar";	
			//var _mediaFilename="";
			//var _trackFilename="";
			var _cfg = cfg;
			var _events = []; //[new CadetEvent(0,10)];
			
			//debug("DATA: _events[0].getTextAsHtml()=["+_events[0].textAsHtml()+"]");


			///PUBLIC METHODS
			this.loadProjectFromFile = loadProjectFromFile;
			//this.setMediaFromFile = setMediaFromFile;
			this.getEvents = getEvents;
			this.count = count;
			this.addEvent = addEvent;
			this.clear = clear;
			this.exportData = exportData;
			this.getIntime = getIntime;
			this.getOuttime = getOuttime;
			this.setIntime = setIntime;
			this.setOuttime = setOuttime;
			this.setMediaFilename = setMediaFilename;
			this.setTrackFilename = setTrackFilename;
			this.getReadyForExport = getReadyForExport;
			this.deleteEvent = deleteEvent;
			this.getLength = getLength;
			//PUBLIC properties -- remember to reset these when they change in various methods
			//_cfg.version = "1001.2016.02.21"	//
			this.config = _cfg;
			//this.mediaFilename = _mediaFilename;//_mediaFilename;
			//this.trackFilename = _trackFilename;//_mediaFilename;
			this.events = _events; //getEvents;
			
			
			function getReadyForExport(){
				//this.mediaFilename = _mediaFilename;//_mediaFilename;
				//this.trackFilename = _trackFilename;//_mediaFilename;
				
				for( var i=0; i<_events.length; i++ ){
					_events[i].getReadyForExport();
				}
				this.events = _events; //getEvents;
			}//getReadyForExport
			
						
			//add a single blank event to start with
			//addEvent(-1,0,0,"Put text here.");
			function getLength(){
				return(_events.length);
			}//getLength
			function getMediaFilename(){
				return _mediaFilename;
			}//getMediaFileName
			function setMediaFilename(s){
				_mediaFilename = s;
				this.mediaFilename = s;
			}//setMediaFileName
			function getTrackFilename(){
				return _trackFilename;
			}//getTrackFileName
			function setTrackFilename(s){
				_trackFilename = s;
				this.trackFilename = s;
			}//setTrackFileName
						
			function getIntime(i){
				return( _events[i].getIntime() );
			}//getIntime
			function getOuttime(i){
				return( _events[i].getOuttime() );
			}//getOuttime
			function setIntime(i, ntime){
				//update model
				_events[i].setIntime(ntime);
			}//setIntime
			function setOuttime(i, ntime){
				//update model
				_events[i].setOuttime(ntime);
			}//setOuttime
			
			
			function clear(){
				//debug("DATA: clear");
				_events = [];
			}//clear
			
			function count(){
				return _events.length;
			}//clear

			function getEvents(){
				return _events;
			}//getEvents

			function addEvent(iwhere, nin, nout, stext, shtmltext) {
				//debug("DATA:addEvent");
				if( iwhere < 0 ) iwhere = 0; //append at top.... or just return; ???
				if( iwhere >= _events.length ){
					iwhere = _events.length;	//append to the end
				}
				
				_events.splice(iwhere, 0, new CadetEvent(nin,nout,stext,shtmltext)) ;
				//debug("DATA:addEvent event count=["+_events.length+"]");
				this.events = _events;//reassign the public property
				return(_events[iwhere]);
			}//addEvent

			function deleteEvent(iwhere, howmany) {
				if( iwhere < 0 ) iwhere = 0; //append at top.... or just return; ???
				if( iwhere >= _events.length ) iwhere = _events.length;	//append to the end
				if( iwhere+howmany >= _events.length) howmany=1;
				
				_events.splice(iwhere, howmany) ;
				this.events = _events;//reassign the public property
			}//deleteEvent

			function loadProjectFromFile(fileObject) {
				alert("CCDATA: loadProjectFromFile file=["+fileObject.name+"]");
				if (fileObject) {
					var reader = new FileReader();
					//attach the load event
					reader.addEventListener("load", function(event) {
										alert("file load event fired");
										var projFile = event.target;
										alert("content=["+projFile.result+"]");
										//var div = document.createElement("div");
										//div.innerText = textFile.result;
										//output.insertBefore(div, null);					
									   });
					
					//tryy to load
					reader.readAsText(fileObject);
				} else { 
					alert("CCDATA: loadProjectFromFile: Failed to load from file=["+fileObject.name+"]");
				}
			}//loadProjectFromFile

/*			
			function setMediaFromFile(f){
				debug("DATA: setMediaFromFile(f)");
				var URL = window.URL || window.webkitURL;
				var fileURL = URL.createObjectURL(f);
				//alert("CadetData:setMediaFromFile: filename=["+f.name+"]");
				//$("video")[0].src="http://localhost:"+cfg.port+"/clips/"+f.name;  //fileURL;
				$("video")[0].src="clips/"+f.name;  //fileURL;
				var basename;
				ttname = f.name.substring(0,f.name.lastIndexOf(".")) + ".temp.vtt";
				setTrackFilename( ttname );
				debug("f.name=["+f.name+"]   matching vtt file=["+_trackFilename+"]");
				//var trksrc=$(trk).attr("src");
				//debug( "number of text tracks=" + $("video")[0].textTracks.length  );
				//var trk=$("video")[0].textTracks[0];
				var trk=$("video > track")[0];
				trk.src="clips/"+ttname;  //fileURL;
				$('#mediaName').text(f.name);
				//now extract and save the filename
				_mediaFilename = f.name;
				setMediaFilename( _mediaFilename );
				debug("DATA:setMediaFromFile: mediaFilename=["+f.name+"]");
				debug("DATA:setMediaFromFile: fileURL=["+fileURL+"]");
				//free up memory by destroying the url
				//URL.revokeObjectURL(fileURL);
			}
*/
			
			function exportData(){
				debug("DATA: exportData");
				for( var i=0; i<_events.length; i++ ){
					debug("event#=["+(i+1)+"] in=["+_events[i].intime().toTimecode()+"] out=["+_events[i].outtime().toTimecode()+"] text=["+_events[i].textAsHtml()+"]");
				}//each event
			}

			return( this );

		} // CadetData Module constructor

//	}); // ready


}) (); //CadetData



/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
//
//	C a d e t E v e n t
//
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
(function  () {

//	$(document).ready (function () {


		var moduleName = "CadetEvent"; // constructor
		var instanceCount = 0;

		// here we assign the constructor to the global variable, but we could assign an instance if we wanted to provide a singleton
		var module = window[moduleName] = Module;

		/*
			function Module (userOptions) {
			var options = {
				_theTable: null,
			}; // defaults
			//options = _.extend (options, userOptions);
		*/	
	
		function Module (nin, nout, stext, shtmltext) {
			/// PRIVATE INSTANCE VARIABLES	
			//var foo = "bar";	
			var _intime = nin;
			var _outtime = nout;
			var _text = stext;
			var _htmltext = shtmltext;
			var _textalign = ALIGN_CENTER;
			var _textRuns = [] ; //[new CadetTextRun("hello",true,false), new CadetTextRun(" world",false,true)];

			//debug("EVENT: _textRuns.length=["+_textRuns.length+"]");
			//debug("EVENT: _textRuns[0].text=["+_textRuns[0].text+"]");
			//debug("EVENT: _textRuns[1].text=["+_textRuns[1].text+"]");
			//debug("EVENT: textAsHtml=["+getTextAsHtml()+"]");
			
			///PUBLIC METHODS
			this.intime = _intime;//getIntime;
			this.getIntime = getIntime;
			this.setIntime = setIntime;
			this.outtime = _outtime;//getOuttime;
			this.getOuttime = getOuttime;
			this.setOuttime = setOuttime;
			this.text = _text;
			this.align = _textalign;
			this.htmlText = _htmltext;
			this.textAsHtml = getTextAsHtml;
			this.getHtmlText = getHtmlText;
			this.setHtmlText = setHtmlText;
			this.add = addRun;
			this.appendRun = appendRun;
			this.getRuns = getRuns;
			this.getRunIndex = getRunIndex;
			this.insertString = insertString;
			this.backSpace = backSpace;
			this.textRuns = _textRuns;
			this.setTextAlign = setTextAlign;
			this.getReadyForExport = getReadyForExport;
			
			function getReadyForExport(){
				updatePlainText();
				//this.mediaFilename = _mediaFilename;//_mediaFilename;
				//this.trackFilename = _trackFilename;//_mediaFilename;
				this.align = _textalign;
				this.text = _text;
			}//getReadyForExport
			
						

			//add a single run with the passed text
			/**/
			//addRun(0, stext, new CadetStyle() );
			/*
			addRun(0, stext.substring(0,4), new CadetStyle(true,false,false,"white","black") );
			addRun(1, "", new CadetStyle(false,true,false,"white","black",true) );
			addRun(2, stext.substring(4,9), new CadetStyle(false,true,false,"white","black") );
			addRun(3, stext.substring(9), new CadetStyle(false,false,true,"white","black") );
			*/
			function addRun(iwhere, stext, somestyle) {
				if( iwhere<0 ) iwhere = 0;//default to first run
				_textRuns.splice(iwhere, 0, new CadetTextRun(_textRuns.length, stext,somestyle) ) ;
			}//addRun
			function appendRun(stext, somestyle) {
				_textRuns.splice(_textRuns.length, 0, new CadetTextRun(_textRuns.length, stext,somestyle) ) ;
			}//appendRun
			
			//get array of runs which include start and end index
			function getRuns(){
			}//getRuns
			
			function getHtmlText(){
				return( _htmltext );
			}//getHtmlText
			function setHtmlText(s){
				_htmltext = s;
			}//setHtmlText
			
			function getIntime(){
				return(_intime);
			}//getIntime
			function setIntime(ntime){
				this._intime = ntime;
				this.intime = ntime;
			}//setIntime
			function getOuttime(){
				return(_outtime);
			} //getOuttime
			function setOuttime(ntime){
				this._outtime = ntime;
				this.outtime = ntime;
			}//setOuttime
			function setTextAlign( iwhich ){
				_textalign = iwhich;
			}//setTextAlign

			function getTextAsHtml(){
				var sfoo = "", sfoo2="", somerun;
				for (i=0; i<_textRuns.length; ++i) {
					somerun = _textRuns[i];
					/*
					sfoo2=somerun.text;
					if( somerun.italic ) sfoo2 = "<i>"+sfoo2+"</i>";
					if( somerun.bold ) sfoo2 = "<b>"+sfoo2+"</b>";
					sfoo += sfoo2;
					*/
					sfoo += (somerun.getTextAsHtml());
					//debug("EVENT: textAsHtml=["+sfoo+"]");
				}
				return(sfoo);
			} //getTextAsHtml

			function updatePlainText(){
				var sfoo = "", sfoo2="", somerun;
				for (i=0; i<_textRuns.length; ++i) {
					somerun = _textRuns[i];
					sfoo = somerun.getText();
					if( i == 0 )
						sfoo2 += sfoo;
					else
						sfoo2 += (" "+sfoo);
				}
				_text = sfoo2;
				return;
			} //updatePlainText
			
			function getRunIndex(sid){
				var tr;
				for(var i=0; i<_textRuns.length; i++){
					if( _textRuns[i].id == sid )
						return(i);
				}
				return(-1); //not found
			}//getRunIndex
			
			function insertString(s){
				//debug("EVENT:insertString enter with ["+s+"]");
				//insert the string
				//get the current selection details
				var cs;
				cs = new CadetSelection(this);
				if( (cs.iStartRun() == cs.iEndRun())){ //selection all within same run, just splice the text in
					var t=_textRuns[cs.iStartRun()].getText();
					var part1, part2;
					part1 = t.slice(0,cs.iStartOffset());
					part2 = t.slice(cs.iStartOffset());
					t = part1 + s + part2;
					//debug("EVENT:insertString same run new text=["+t+"]");
					_textRuns[cs.iStartRun()].setText(t);
					
				} else if( true ){
				}

			}//insertString
			
			function backSpace(){
				debug("EVENT:backSpace enter");
				//get the current selection details
				var cs;
				cs = new CadetSelection(this);
				if( (cs.iStartRun() == cs.iEndRun())){ //selection all within same run, just splice the text in
					var t=_textRuns[cs.iStartRun()].getText();
					var part1, part2;
					part1 = t.slice(0,cs.iStartOffset()-1);
					part2 = t.slice(cs.iStartOffset());
					t = part1+part2;
					//debug("EVENT:insertString same run new text=["+t+"]");
					_textRuns[cs.iStartRun()].setText(t);
					
				} else if( true ){
				}
			}
			
			return( this );
						
		} // CadetEvent Module constructor

//	}); // ready


}) (); // CadetEvent



/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
//
//	C a d e t T e x t R u n
//
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
(function  () {

//	$(document).ready (function () {


		var moduleName = "CadetTextRun"; // constructor
		var instanceCount = 0;

		// here we assign the constructor to the global variable, but we could assign an instance if we wanted to provide a singleton
		var module = window[moduleName] = Module;

		/*
			function Module (userOptions) {
			var options = {
				_theTable: null,
			}; // defaults
			//options = _.extend (options, userOptions);
		*/	
	
		function Module (id, stext, ostyle) {
			/// PRIVATE INSTANCE VARIABLES	
			//var foo = "bar";	
			var _id = id;
			var _text = stext;
			var _style = ostyle;
			
			///PUBLIC METHODS
			this.id = _id;
			this.text = _text;
			this.bold = _style.bold;
			this.italic = _style.italic;
			this.underline = _style.underline;
			this.linebreak = _style.linebreak;
			this.color = _style.color;
			this.bgcolor = _style.bgcolor;
			this.getText = getText;
			this.setText = setText;
			this.getStyle = getStyle;
			this.setStyle = setStyle;
			this.getTextAsHtml = getTextAsHtml;
			
			function getText(){
				return( _text );
			}//getText
			function setText(s){
				_text = s;
			}//setText
			function getStyle(){ return( _style ) }
			function setStyle(o){
				_style = o;
			}
			
			function getTextAsHtml(){
				if( _style.linebreak )
					return("<br id='"+_id.toString()+"' />");

				var stylestring = "";
				stylestring = ("font-weight: " + (_style.bold ? "bold" : "normal") + "; ");
				stylestring += ("font-style: " + (_style.italic ? "italic" : "normal") + "; ");
				stylestring += ("text-decoration: " + (_style.underline ? "underline" : "none") + "; ");
				stylestring += ("color: " + _style.color + "; ");
				stylestring += ("background-color: " + _style.bgcolor + "; ");
				stylestring = "<span id='"+_id.toString()+"' style='" + stylestring + "'>";
				
				var sfoo;
				sfoo = stylestring + _text + "</span>";
				//debug("RUN: getTextAsHtml=["+encodeURI(sfoo)+"]");
				
				return(sfoo);
			}//getTextAsHtml
			
			return( this );

		} // CadetTextRun Module constructor

//	}); // ready


}) (); // CadetTextRun



/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
//
//	C a d e t S t y l e
//
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
(function  () {

//	$(document).ready (function () {


		var moduleName = "CadetStyle"; // constructor
		var instanceCount = 0;

		// here we assign the constructor to the global variable, but we could assign an instance if we wanted to provide a singleton
		var module = window[moduleName] = Module;

		/*
			function Module (userOptions) {
			var options = {
				_theTable: null,
			}; // defaults
			//options = _.extend (options, userOptions);
		*/	
	
		function Module (b, i, u, c, bgc, linebreak) {
			/// PRIVATE INSTANCE VARIABLES	
			var _bold;
			var _italic;
			var _underline;
			var _color;
			var _bgcolor;
			var _linebreak;
			_bold = (typeof b != 'undefined') ? b : false;
			_italic = (typeof i != 'undefined') ? i : false;
			_underline = (typeof u != 'undefined') ? u : false;
			_color = (typeof c != 'undefined') ? c : "white";
			_bgcolor = (typeof bgc != 'undefined') ? bgc : "black";
			_linebreak = (typeof linebreak != 'undefined') ? linebreak : false;
			
			///PUBLIC METHODS
			this.bold = _bold;
			this.italic = _italic;
			this.underline = _underline;
			this.color = _color;
			this.bgcolor = _bgcolor;
			this.linebreak = _linebreak;
			this.getBold = getBold;
			this.setBold = setBold;
			this.getItalic = getItalic;
			this.setItalic = setItalic;
			this.getUnderline = getUnderline;
			this.setUnderline = setUnderline;
			this.getLinebreak = getLinebreak;
			this.setLinebreak = setLinebreak;
			this.getColor = getColor;
			this.setColor = setColor;
			this.getBGColor = getBGColor;
			this.setBGColor = setBGColor;
			this.toString=toString;
			//this.toSpan = toSpan;
			
			function getBold(){return(_bold);}
			function setBold(b){_bold=b;}
			function getItalic(){return(_italic);}
			function setItalic(b){_italic=b;}
			function getUnderline(){return(_underline);}
			function setUnderline(b){_underline=b;}
			function getLinebreak(){return(_linebreak);}
			function setLinebreak(b){_linebreak=b;this.linebreak = _linebreak;}
			function getColor(){return(_color);}
			function setColor(c){_color=c;}
			function getBGColor(){return(_bgcolor);}
			function setBGColor(c){_bgcolor=c;}
			
			/*
			function toSpan(){
				if( _linebreak )
					return("<br />");
			
			
				var stylestring = "";
				stylestring = ("font-weight: " + (_bold ? "bold" : "normal") + "; ");
				stylestring += ("font-style: " + (_italic ? "italic" : "normal") + "; ");
				stylestring += ("text-decoration: " + (_underline ? "underline" : "none") + "; ");
				stylestring += ("color: " + _color + "; ");
				stylestring += ("background-color: " + _bgcolor + "; ");
				stylestring = "<span style='" + stylestring + "'>";
				
				var sfoo;
				sfoo = stylestring + "***" + "</span>";
				debug("STYLE: toSpan=["+sfoo+"]");
				
				return(sfoo);
			}//toSpan
			*/
			function toString(){
				var sfoo="";
				//sfoo += " linebreak:"+_linebreak;
				sfoo += "bold:"+_bold;
				sfoo += ", italic:"+_italic;
				sfoo += ", underline:"+_underline;
				sfoo += ", color:"+_color;
				sfoo += ", bgcolor:"+_bgcolor;
				return(sfoo.trim());
			}
			
			return(this);
			
		} // CadetStyle Module constructor

//	}); // ready


}) (); // CadetStyle


/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
//
//	C a d e t C o n f i g
//
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
(function  () {

//	$(document).ready (function () {


		var moduleName = "CadetConfig"; // constructor
		var instanceCount = 0;

		// here we assign the constructor to the global variable, but we could assign an instance if we wanted to provide a singleton
		var module = window[moduleName] = Module;

		/*
			function Module (userOptions) {
			var options = {
				_theTable: null,
			}; // defaults
			//options = _.extend (options, userOptions);
		*/	
	
		function Module (p, hd, md) {
			/// PRIVATE INSTANCE VARIABLES	
			//var foo = "bar";	
			var _port = p;
			var _homeDir = hd;
			var _mediaFilename;
			var _mediaDir = md;
			var _trackFilename = "";
			var _trackDir = md; //same as media dir, always
			var _webProjectDir = DEFAULT_WEBPROJECT_DIR;
			var _webProjectFile = DEFAULT_WEBPROJECT_FILE
			var _defaultStyle;
			
			//debug("CONFIG: mediaDir=["+_mediaDir+"]");


			///PUBLIC METHODS
			this.cadetVersion = VERSION;
			this.port = _port;
			this.homeDir = _homeDir;
			this.mediaDir = _mediaDir;
			this.setDefaultStyle = setDefaultStyle;
			this.mediaFilename = "";
			this.webProjectPath = "";
			this.setMediaFilename = setMediaFilename;
			this.setMediaInfo = setMediaInfo;
			this.getReadyForExport = getReadyForExport;
			this.setWebProject = setWebProject;
			this.getMediaFilename = getMediaFilename;
			this.webProjectDir = _webProjectDir;
			this.webProjectFile = _webProjectFile;
			this.setExportCoords = setExportCoords;
			//this.setTrackFilename = setMediaFilename;
			
			function getReadyForExport(){
				this.cadetVersion = VERSION;
				this.mediaFilename = _mediaFilename;//_mediaFilename;
				this.mediaDir = _mediaDir;
				this.trackFilename = _trackFilename;//_mediaFilename;
				this.webProjectDir = _webProjectDir;
				this.webProjectFile = _webProjectFile;
				this.webProjectPath = _webProjectDir + "/" +  _webProjectFile;
			}//getReadyForExport
			
			function setExportCoords(dir, file, etype){
				this.exportFilename = file;
				this.exportDir = dir;
				this.exportType = etype;
			}
			
			function setWebProject( thedir, thefile ){
				_webProjectDir = thedir.replace(/\/+$/, "");	//always remove trailing slash
				_webProjectFile = thefile;
				this.webProjectDir = _webProjectDir;
				this.webProjectFile = _webProjectFile;
				//debug("DATA:CONFIG: setWebProject: dir=["+_webProjectDir+"] file=["+_webProjectFile+"]");
			}//setWebProject


			function setMediaFilename(s){
				debug("DATA:CONFIG: enter setMediaFilename");
				_mediaFilename = s;
				//this.mediaFilename = s;
				
				var basename;
				ttname = s.substring(0,s.lastIndexOf(".")) + ".temp.vtt";
				_trackFilename = ttname;
				//this.trackFilename = ttname;
			}//setMediaFilename
			
			function getMediaFilename(){
				if( _mediaFilename && _mediaFilename.length > 0 ){
					return _mediaFilename ;
				} else {
					return null;
				}
			}//getMediaFilename

			function setMediaInfo(sfile, sdir){
				//debug("DATA:CONFIG: enter setMediaInfo");
				_mediaFilename = sfile;
				_mediaDir = sdir
				
				var basename;
				ttname = sfile.substring(0,sfile.lastIndexOf(".")) + ".temp.vtt";
				_trackFilename = ttname;
				_trackDir = sdir; //by default
			}//setMediaInfo
			

			function setDefaultStyle(){
			}//setDefaultStyle


		} // CadetConfig Module constructor

//	}); // ready


}) (); // CadetConfig


/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
//
//	C a d e t S e l e c t i o n
//
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
(function  () {

//	$(document).ready (function () {


		var moduleName = "CadetSelection"; // constructor
		var instanceCount = 0;

		// here we assign the constructor to the global variable, but we could assign an instance if we wanted to provide a singleton
		var module = window[moduleName] = Module;

		/*
			function Module (userOptions) {
			var options = {
				_theTable: null,
			}; // defaults
			//options = _.extend (options, userOptions);
		*/	
	
		function Module (cadetEvent) { //currrent event passed in because we'll need to find specific runs
			/// PRIVATE INSTANCE VARIABLES	
			//var foo = "bar";	
			var _iStartRun;
			var _iEndRun;
			var _iStartOffset;
			var _iEndOffset;
			var _text;


			///PUBLIC METHODS
			this.iStartRun = iStartRun;
			this.iEndRun = iEndRun;
			this.iStartOffset = iStartOffset;
			this.iEndOffset = iEndOffset;
			this.text = text;
			this.collapse = collapse;
			
			var userSelection;// = window.getSelection();
			if (window.getSelection) {
				userSelection = window.getSelection();
			}
			else if (document.selection) { // should come last; Opera!
				userSelection = document.selection.createRange();
			}
			
			//NOTES: Firefox always presents baseNode and extentNode; Safari/Chrome offer anchorNode/focusNode
			//	Needs to be a text-type node for proper offsets
			var startID, startOffset, endID, endOffset;
			if( userSelection.baseNode ){
				startID = userSelection.baseNode.parentElement.id;
				startOffset = userSelection.baseOffset;
				endID = userSelection.extentNode.parentElement.id;
				endOffset = userSelection.extentOffset;
			} else {
				startID = userSelection.anchorNode.parentElement.id;
				startOffset = userSelection.anchorOffset;
				endID = userSelection.focusNode.parentElement.id;
				endOffset = userSelection.focusOffset;
			}
			//debug("EDITOR: getSelection: startID=["+startID+"] startOffset=["+startOffset+"]");
			//debug("EDITOR: getSelection: endID=["+endID+"] endOffset=["+endOffset+"]");
			
			
			_iStartRun = cadetEvent.getRunIndex(startID);
			_iEndRun = cadetEvent.getRunIndex(endID);
			_iStartOffset = startOffset;
			_iEndOffset = endOffset;
			//debug("SELECTION:instantiate: _iStartRun=["+_iStartRun+"] _iEndRun=["+_iEndRun+"] _iStartOffset=["+_iStartOffset+"] _iEndOffset=["+_iEndOffset+"]");
			
			//now make a range out of it
			var rang;
			if (userSelection.getRangeAt)
				rang = userSelection.getRangeAt(0);
			else { // Safari!
				rang = document.createRange();
				rang.setStart(selectionObject.anchorNode,selectionObject.anchorOffset);
				rang.setEnd(selectionObject.focusNode,selectionObject.focusOffset);
			}
			//debug("SELECTION:instantiate: sel text=["+rang.toString()+"]");
			_text = rang.toString();

			function iStartRun(){
				return( _iStartRun );
			}//iStartRun
			function iEndRun(){
				return( _iEndRun );
			}//iEndRun
			function iStartOffset(){
				return( _iStartOffset );
			}//iStartOffset
			function iEndOffset(){
				return( _iEndOffset );
			}//iEndOffset
			function text(){
				return( _text );
			}//text
			function collapse(){
				debug("SELECTION:collapse: enter");
				//collapse the selection and update values of start/end, start will equal end for index and 
				_text = "";
			}//collapse

			return( this );
			
		} // CadetSelection Module constructor

//	}); // ready

}) (); // CadetSelection




